Scriptname FM_MCMScript extends SKI_ConfigBase

; Widgets

Import FISSFactory

FM_Follower1WidgetScript Property Follower1Script Auto
FM_Follower2WidgetScript Property Follower2Script Auto
FM_Follower3WidgetScript Property Follower3Script Auto
FM_Follower4WidgetScript Property Follower4Script Auto
FM_Follower5WidgetScript Property Follower5Script Auto

FM_WidgetManagerScript Property UpdateScript Auto

Int FollowerWidget1
Int FollowerPosX1
Int FollowerPosY1
Int FollowerAnchorH1
Int FollowerAnchorV1
Int FollowerAlpha1
Int FollowerScale1
Int FollowerWidget2
Int FollowerPosX2
Int FollowerPosY2
Int FollowerAnchorH2
Int FollowerAnchorV2
Int FollowerAlpha2
Int FollowerScale2
Int FollowerWidget3
Int FollowerPosX3
Int FollowerPosY3
Int FollowerAnchorH3
Int FollowerAnchorV3
Int FollowerAlpha3
Int FollowerScale3
Int FollowerWidget4
Int FollowerPosX4
Int FollowerPosY4
Int FollowerAnchorH4
Int FollowerAnchorV4
Int FollowerAlpha4
Int FollowerScale4
Int FollowerWidget5
Int FollowerPosX5
Int FollowerPosY5
Int FollowerAnchorH5
Int FollowerAnchorV5
Int FollowerAlpha5
Int FollowerScale5

String[] HAnchorFollowerString1
String[] VAnchorFollowerString1
String[] HAnchorFollowerString2
String[] VAnchorFollowerString2
String[] HAnchorFollowerString3
String[] VAnchorFollowerString3
String[] HAnchorFollowerString4
String[] VAnchorFollowerString4
String[] HAnchorFollowerString5
String[] VAnchorFollowerString5

Int UpdateTimerInt
Int FissLoad
Int FissSave

; combat style lists

string[] CSList1
string[] CSList2
string[] CSList3
string[] CSList4
string[] CSList5
Int CStyle1
Int CStyle2
Int CStyle3
Int CStyle4
Int CStyle5
Int Property CStyleIndex1 Auto
Int Property CStyleIndex2 Auto
Int Property CStyleIndex3 Auto
Int Property CStyleIndex4 Auto
Int Property CStyleIndex5 Auto

; Settings

Int BumpTime
Int WeapDraw
Int CarryWeightPointsFollower1
Int CarryWeightPointsFollower2
Int CarryWeightPointsFollower3
Int CarryWeightPointsFollower4
Int CarryWeightPointsFollower5
Int SpeedPointsFollower1
Int SpeedPointsFollower2
Int SpeedPointsFollower3
Int SpeedPointsFollower4
Int SpeedPointsFollower5
Int AggressionFollower1
Int AggressionFollower2
Int AggressionFollower3
Int AggressionFollower4
Int AggressionFollower5
Int ConfidenceFollower1
Int ConfidenceFollower2
Int ConfidenceFollower3
Int ConfidenceFollower4
Int ConfidenceFollower5
Int AssistanceFollower1
Int AssistanceFollower2
Int AssistanceFollower3
Int AssistanceFollower4
Int AssistanceFollower5
Int MoralityFollower1
Int MoralityFollower2
Int MoralityFollower3
Int MoralityFollower4
Int MoralityFollower5
Int ResetAll

Bool BumpTimeToggle = false
Bool WeapDrawToggle = false
Bool PressedKeyOnceLockBack = false
Bool WeaponDrawn = false

Float CarryWeightPointsFollowerSlider1 = 300.00
Float CarryWeightPointsFollowerSlider2 = 300.00
Float CarryWeightPointsFollowerSlider3 = 300.00
Float CarryWeightPointsFollowerSlider4 = 300.00
Float CarryWeightPointsFollowerSlider5 = 300.00
Float SpeedPointsFollowerSlider1 = 100.00
Float SpeedPointsFollowerSlider2 = 100.00
Float SpeedPointsFollowerSlider3 = 100.00
Float SpeedPointsFollowerSlider4 = 100.00
Float SpeedPointsFollowerSlider5 = 100.00
Float FollowerAggressionSlider1 = 1.00
Float FollowerAggressionSlider2 = 1.00
Float FollowerAggressionSlider3 = 1.00
Float FollowerAggressionSlider4 = 1.00
Float FollowerAggressionSlider5 = 1.00
Float FollowerConfidenceSlider1 = 4.00
Float FollowerConfidenceSlider2 = 4.00
Float FollowerConfidenceSlider3 = 4.00
Float FollowerConfidenceSlider4 = 4.00
Float FollowerConfidenceSlider5 = 4.00
Float FollowerAssistanceSlider1 = 2.00
Float FollowerAssistanceSlider2 = 2.00
Float FollowerAssistanceSlider3 = 2.00
Float FollowerAssistanceSlider4 = 2.00
Float FollowerAssistanceSlider5 = 2.00
Float FollowerMoralitySlider1 = 3.00
Float FollowerMoralitySlider2 = 3.00
Float FollowerMoralitySlider3 = 3.00
Float FollowerMoralitySlider4 = 3.00
Float FollowerMoralitySlider5 = 3.00

; Hotkeys

Int KeyQuickTrade
Int KeyTrade
Int KeyQuickCommand
Int KeyCommand
Int KeyQuickSummon
Int KeySummon
Int KeyQuickRelax
Int KeyRelax
Int KeyQuickAvoid
Int KeyAvoid
Int KeyQuickLookBack
Int KeyLookBack
Int KeyQuickDrawWeapon
Int KeyDrawWeapon

; Properties

Actor Property PlayerREF Auto
Faction Property CurrentFollowerFaction Auto
Faction Property FM_RelaxFaction Auto
Faction Property FM_AvoidCombatFaction Auto
VisualEffect Property MGTeleportOutEffect Auto
VisualEffect Property MGTeleportInEffect Auto
ReferenceAlias[] Property AliasArrayCommands Auto
ReferenceAlias Property CameraFollower Auto
ReferenceAlias Property FirstFollower Auto
ReferenceAlias Property SecondFollower Auto
ReferenceAlias Property ThirdFollower Auto
ReferenceAlias Property FourthFollower Auto
ReferenceAlias Property FifthFollower Auto
ReferenceAlias[] Property AliasArray Auto
FormList Property FM_CombatStyleFL Auto

Event OnConfigInit()

	HAnchorFollowerString1 = new String[3]
	HAnchorFollowerString1[0] = "Left"
	HAnchorFollowerString1[1] = "Right"
	HAnchorFollowerString1[2] = "Center"
	HAnchorFollowerString2 = new String[3]
	HAnchorFollowerString2[0] = "Left"
	HAnchorFollowerString2[1] = "Right"
	HAnchorFollowerString2[2] = "Center"
	HAnchorFollowerString3 = new String[3]
	HAnchorFollowerString3[0] = "Left"
	HAnchorFollowerString3[1] = "Right"
	HAnchorFollowerString3[2] = "Center"
	HAnchorFollowerString4 = new String[3]
	HAnchorFollowerString4[0] = "Left"
	HAnchorFollowerString4[1] = "Right"
	HAnchorFollowerString4[2] = "Center"
	HAnchorFollowerString5 = new String[3]
	HAnchorFollowerString5[0] = "Left"
	HAnchorFollowerString5[1] = "Right"
	HAnchorFollowerString5[2] = "Center"

	VAnchorFollowerString1 = new String[3]
	VAnchorFollowerString1[0] = "Bottom"
	VAnchorFollowerString1[1] = "Top"
	VAnchorFollowerString1[2] = "Center"
	VAnchorFollowerString2 = new String[3]
	VAnchorFollowerString2[0] = "Bottom"
	VAnchorFollowerString2[1] = "Top"
	VAnchorFollowerString2[2] = "Center"	
	VAnchorFollowerString3 = new String[3]
	VAnchorFollowerString3[0] = "Bottom"
	VAnchorFollowerString3[1] = "Top"
	VAnchorFollowerString3[2] = "Center"	
	VAnchorFollowerString4 = new String[3]
	VAnchorFollowerString4[0] = "Bottom"
	VAnchorFollowerString4[1] = "Top"
	VAnchorFollowerString4[2] = "Center"	
	VAnchorFollowerString5 = new String[3]
	VAnchorFollowerString5[0] = "Bottom"
	VAnchorFollowerString5[1] = "Top"
	VAnchorFollowerString5[2] = "Center"
	
	CSList1 = new string[12]
	CSList1[0] = "Archer"
	CSList1[1] = "Warrior"
	CSList1[2] = "Magician"
	CSList1[3] = "Scout"
	CSList1[4] = "Berserk"
	CSList1[5] = "Wizard"
	CSList1[6] = "Assassin"
	CSList1[7] = "Monk"
	CSList1[8] = "Spellsword"
	CSList1[9] = "Bard"
	CSList1[10] = "Soldier"
	CSList1[11] = "Dragonborn"
	CSList2 = new string[12]
	CSList2[0] = "Archer"
	CSList2[1] = "Warrior"
	CSList2[2] = "Magician"
	CSList2[3] = "Scout"
	CSList2[4] = "Berserk"
	CSList2[5] = "Wizard"
	CSList2[6] = "Assassin"
	CSList2[7] = "Monk"
	CSList2[8] = "Spellsword"
	CSList2[9] = "Bard"
	CSList2[10] = "Soldier"
	CSList2[11] = "Dragonborn"
	CSList3 = new string[12]
	CSList3[0] = "Archer"
	CSList3[1] = "Warrior"
	CSList3[2] = "Magician"
	CSList3[3] = "Scout"
	CSList3[4] = "Berserk"
	CSList3[5] = "Wizard"
	CSList3[6] = "Assassin"
	CSList3[7] = "Monk"
	CSList3[8] = "Spellsword"
	CSList3[9] = "Bard"
	CSList3[10] = "Soldier"
	CSList3[11] = "Dragonborn"
	CSList4 = new string[12]
	CSList4[0] = "Archer"
	CSList4[1] = "Warrior"
	CSList4[2] = "Magician"
	CSList4[3] = "Scout"
	CSList4[4] = "Berserk"
	CSList4[5] = "Wizard"
	CSList4[6] = "Assassin"
	CSList4[7] = "Monk"
	CSList4[8] = "Spellsword"
	CSList4[9] = "Bard"
	CSList4[10] = "Soldier"
	CSList4[11] = "Dragonborn"
	CSList5 = new string[12]
	CSList5[0] = "Archer"
	CSList5[1] = "Warrior"
	CSList5[2] = "Magician"
	CSList5[3] = "Scout"
	CSList5[4] = "Berserk"
	CSList5[5] = "Wizard"
	CSList5[6] = "Assassin"
	CSList5[7] = "Monk"
	CSList5[8] = "Spellsword"
	CSList5[9] = "Bard"
	CSList5[10] = "Soldier"
	CSList5[11] = "Dragonborn"	
	
	RestoreActorValues()
	
EndEvent

Event OnGameReload()
	Parent.OnGameReload()
	RestoreActorValues()
EndEvent

Event OnPageReset(string Page)

	Int FollowerFlag1
	If (Page == "Main Page")
		SetCursorFillMode(TOP_TO_BOTTOM)
		SetCursorPosition(0)
		AddHeaderOption("Configuration")
		BumpTime = AddToggleOption("Follower Response", BumpTimeToggle, FollowerFlag1)
		WeapDraw = AddToggleOption("Follower Draw Weapon", WeapDrawToggle, FollowerFlag1)		
		ResetAll = AddTextOption("Reset all Hotkeys!", "Click me!")
		UpdateTimerInt = AddSliderOption("Update Timer Interval", UpdateScript.UpdateTimer, "{0} sec.")	
		FISSInterface fiss = FISSFactory.getFISS()
		Int FissFlag = OPTION_FLAG_NONE
		Int LoadSettingsFlag = OPTION_FLAG_NONE
		If !fiss
			FissFlag = OPTION_FLAG_DISABLED
			LoadSettingsFlag = OPTION_FLAG_DISABLED
		Else
			fiss.beginLoad("FMUserSettings.xml")		
			If fiss.endLoad() != ""
				LoadSettingsFlag = OPTION_FLAG_DISABLED
			EndIf
		EndIf		
		FissLoad = AddTextOption("Load User Settings?", "Do it!", LoadSettingsFlag)
		FissSave = AddTextOption("Save User Settings?", "Do it!", FissFlag)
		SetCursorPosition(1)		
		AddHeaderOption("Key Mapping - Followers")		
		KeyQuickTrade = AddKeyMapOption("Trade Hotkey", KeyTrade)
		KeyQuickCommand = AddKeyMapOption("Command Hotkey", KeyCommand)
		KeyQuickSummon = AddKeyMapOption("Call/Summon Hotkey", KeySummon)
		KeyQuickRelax = AddKeyMapOption("Relax Hotkey", KeyRelax)
		KeyQuickAvoid = AddKeyMapOption("Avoid Combat Hotkey", KeyAvoid)
		KeyQuickLookBack = AddKeyMapOption("Look at Follower Hotkey", KeyLookBack)
		KeyQuickDrawWeapon = AddKeyMapOption("Follower Draw Weapon Hotkey", KeyDrawWeapon)
	ElseIf (Page == "First Follower")
		SetCursorFillMode(TOP_TO_BOTTOM)
		SetCursorPosition(0)
		AddHeaderOption("Settings")	
		If !AliasArray[0].GetActorReference().IsPlayerTeammate()
			FollowerFlag1 = OPTION_FLAG_DISABLED
		EndIf
		CStyle1 = AddMenuOption("Choose Combat Style", CSList1[CStyleIndex1], FollowerFlag1)		
		CarryWeightPointsFollower1 = AddSliderOption("First Follower Carry Weight", CarryWeightPointsFollowerSlider1, "{1}", FollowerFlag1)
		SpeedPointsFollower1 = AddSliderOption("First Follower Speed", SpeedPointsFollowerSlider1, "{1}", FollowerFlag1)
		AggressionFollower1 = AddSliderOption("First Follower Aggression", FollowerAggressionSlider1, "{1}", FollowerFlag1)
		ConfidenceFollower1 = AddSliderOption("First Follower Confidence", FollowerConfidenceSlider1, "{1}", FollowerFlag1)
		AssistanceFollower1 = AddSliderOption("First Follower Assistance", FollowerAssistanceSlider1, "{1}", FollowerFlag1)
		MoralityFollower1 = AddSliderOption("First Follower Morality", FollowerMoralitySlider1, "{1}", FollowerFlag1)
		SetCursorPosition(1)
		AddHeaderOption("Widget")			
		FollowerWidget1 = AddToggleOption("Toggle Follower Counter", Follower1Script.Visible)
		FollowerPosX1 = AddSliderOption("Left/Right-Position", Follower1Script.X, "{0}")
		FollowerPosY1 = AddSliderOption("Up/Down-Position", Follower1Script.Y, "{0}")
		FollowerAnchorV1 = AddMenuOption("Vertical-Anchor", VAnchorFollowerString1[VAnchorFollowerString1.Find(Follower1Script.VAnchor)])		
		FollowerAnchorH1 = AddMenuOption("Horizontal-Anchor", HAnchorFollowerString1[HAnchorFollowerString1.Find(Follower1Script.HAnchor)])
		FollowerAlpha1 = AddSliderOption("Transparency", Follower1Script.Alpha, "{0} %")
		FollowerScale1 = AddSliderOption("Scale", Follower1Script.Size, "{0} %")			
	ElseIf (Page == "Second Follower")
		SetCursorFillMode(TOP_TO_BOTTOM)
		SetCursorPosition(0)
		AddHeaderOption("Settings")		
		Int FollowerFlag2
		If !AliasArray[1].GetActorReference().IsPlayerTeammate()
			FollowerFlag2 = OPTION_FLAG_DISABLED
		EndIf
		CStyle2 = AddMenuOption("Choose Combat Style", CSList2[CStyleIndex2], FollowerFlag2)		
		CarryWeightPointsFollower2 = AddSliderOption("Second Follower Carry Weight", CarryWeightPointsFollowerSlider2, "{1}", FollowerFlag2)
		SpeedPointsFollower2 = AddSliderOption("Second Follower Speed", SpeedPointsFollowerSlider2, "{1}", FollowerFlag2)
		AggressionFollower2 = AddSliderOption("Second Follower Aggression", FollowerAggressionSlider2, "{1}", FollowerFlag2)
		ConfidenceFollower2 = AddSliderOption("Second Follower Confidence", FollowerConfidenceSlider2, "{1}", FollowerFlag2)
		AssistanceFollower2 = AddSliderOption("Second Follower Assistance", FollowerAssistanceSlider2, "{1}", FollowerFlag2)
		MoralityFollower2 = AddSliderOption("Second Follower Morality", FollowerMoralitySlider2, "{1}", FollowerFlag2)
		SetCursorPosition(1)
		AddHeaderOption("Widget")		
		FollowerWidget2 = AddToggleOption("Toggle Follower Counter", Follower2Script.Visible)
		FollowerPosX2 = AddSliderOption("Left/Right-Position", Follower2Script.X, "{0}")
		FollowerPosY2 = AddSliderOption("Up/Down-Position", Follower2Script.Y, "{0}")
		FollowerAnchorV2 = AddMenuOption("Vertical-Anchor", VAnchorFollowerString2[VAnchorFollowerString2.Find(Follower2Script.VAnchor)])		
		FollowerAnchorH2 = AddMenuOption("Horizontal-Anchor", HAnchorFollowerString2[HAnchorFollowerString2.Find(Follower2Script.HAnchor)])
		FollowerAlpha2 = AddSliderOption("Transparency", Follower2Script.Alpha, "{0} %")
		FollowerScale2 = AddSliderOption("Scale", Follower2Script.Size, "{0} %")		
	ElseIf (Page == "Third Follower")
		SetCursorFillMode(TOP_TO_BOTTOM)
		SetCursorPosition(0)
		AddHeaderOption("Settings")		
		Int FollowerFlag3
		If !AliasArray[2].GetActorReference().IsPlayerTeammate()
			FollowerFlag3 = OPTION_FLAG_DISABLED
		EndIf
		CStyle3 = AddMenuOption("Choose Combat Style", CSList3[CStyleIndex3], FollowerFlag3)		
		CarryWeightPointsFollower3 = AddSliderOption("Third Follower Carry Weight", CarryWeightPointsFollowerSlider3, "{1}", FollowerFlag3)
		SpeedPointsFollower3 = AddSliderOption("Third Follower Speed", SpeedPointsFollowerSlider3, "{1}", FollowerFlag3)
		AggressionFollower3 = AddSliderOption("Third Follower Aggression", FollowerAggressionSlider3, "{1}", FollowerFlag3)
		ConfidenceFollower3 = AddSliderOption("Third Follower Confidence", FollowerConfidenceSlider3, "{1}", FollowerFlag3)
		AssistanceFollower3 = AddSliderOption("Third Follower Assistance", FollowerAssistanceSlider3, "{1}", FollowerFlag3)
		MoralityFollower3 = AddSliderOption("Third Follower Morality", FollowerMoralitySlider3, "{1}", FollowerFlag3)
		SetCursorPosition(1)
		AddHeaderOption("Widget")	
		FollowerWidget3 = AddToggleOption("Toggle Follower Counter", Follower3Script.Visible)
		FollowerPosX3 = AddSliderOption("Left/Right-Position", Follower3Script.X, "{0}")
		FollowerPosY3 = AddSliderOption("Up/Down-Position", Follower3Script.Y, "{0}")
		FollowerAnchorV3 = AddMenuOption("Vertical-Anchor", VAnchorFollowerString3[VAnchorFollowerString3.Find(Follower3Script.VAnchor)])		
		FollowerAnchorH3 = AddMenuOption("Horizontal-Anchor", HAnchorFollowerString3[HAnchorFollowerString3.Find(Follower3Script.HAnchor)])
		FollowerAlpha3 = AddSliderOption("Transparency", Follower3Script.Alpha, "{0} %")
		FollowerScale3 = AddSliderOption("Scale", Follower3Script.Size, "{0} %")		
	ElseIf (Page == "Fourth Follower")
		SetCursorFillMode(TOP_TO_BOTTOM)
		SetCursorPosition(0)
		AddHeaderOption("Settings")		
		Int FollowerFlag4
		If !AliasArray[3].GetActorReference().IsPlayerTeammate()
			FollowerFlag4 = OPTION_FLAG_DISABLED
		EndIf
		CStyle4 = AddMenuOption("Choose Combat Style", CSList4[CStyleIndex4], FollowerFlag4)		
		CarryWeightPointsFollower4 = AddSliderOption("Fourth Follower Carry Weight", CarryWeightPointsFollowerSlider4, "{1}", FollowerFlag4)
		SpeedPointsFollower4 = AddSliderOption("Fourth Follower Speed", SpeedPointsFollowerSlider4, "{1}", FollowerFlag4)
		AggressionFollower4 = AddSliderOption("Fourth Follower Aggression", FollowerAggressionSlider4, "{1}", FollowerFlag4)
		ConfidenceFollower4 = AddSliderOption("Fourth Follower Confidence", FollowerConfidenceSlider4, "{1}", FollowerFlag4)
		AssistanceFollower4 = AddSliderOption("Fourth Follower Assistance", FollowerAssistanceSlider4, "{1}", FollowerFlag4)
		MoralityFollower4 = AddSliderOption("Fourth Follower Morality", FollowerMoralitySlider4, "{1}", FollowerFlag4)
		SetCursorPosition(1)
		AddHeaderOption("Widget")		
		FollowerWidget4 = AddToggleOption("Toggle Follower Counter", Follower4Script.Visible)
		FollowerPosX4 = AddSliderOption("Left/Right-Position", Follower4Script.X, "{0}")
		FollowerPosY4 = AddSliderOption("Up/Down-Position", Follower4Script.Y, "{0}")
		FollowerAnchorV4 = AddMenuOption("Vertical-Anchor", VAnchorFollowerString4[VAnchorFollowerString4.Find(Follower4Script.VAnchor)])		
		FollowerAnchorH4 = AddMenuOption("Horizontal-Anchor", HAnchorFollowerString4[HAnchorFollowerString4.Find(Follower4Script.HAnchor)])
		FollowerAlpha4 = AddSliderOption("Transparency", Follower4Script.Alpha, "{0} %")
		FollowerScale4 = AddSliderOption("Scale", Follower4Script.Size, "{0} %")		
	ElseIf (Page == "Fifth Follower")
		SetCursorFillMode(TOP_TO_BOTTOM)
		SetCursorPosition(0)
		AddHeaderOption("Settings")		
		Int FollowerFlag5
		If !AliasArray[4].GetActorReference().IsPlayerTeammate()
			FollowerFlag5 = OPTION_FLAG_DISABLED
		EndIf
		CStyle5 = AddMenuOption("Choose Combat Style", CSList5[CStyleIndex5], FollowerFlag5)		
		CarryWeightPointsFollower5 = AddSliderOption("Fifth Follower Carry Weight", CarryWeightPointsFollowerSlider5, "{1}", FollowerFlag5)
		SpeedPointsFollower5 = AddSliderOption("Fifth Follower Speed", SpeedPointsFollowerSlider5, "{1}", FollowerFlag5)
		AggressionFollower5 = AddSliderOption("Fifth Follower Aggression", FollowerAggressionSlider5, "{1}", FollowerFlag5)
		ConfidenceFollower5 = AddSliderOption("Fifth Follower Confidence", FollowerConfidenceSlider5, "{1}", FollowerFlag5)
		AssistanceFollower5 = AddSliderOption("Fifth Follower Assistance", FollowerAssistanceSlider5, "{1}", FollowerFlag5)
		MoralityFollower5 = AddSliderOption("Fifth Follower Morality", FollowerMoralitySlider5, "{1}", FollowerFlag5)
		SetCursorPosition(1)
		AddHeaderOption("Widget")		
		FollowerWidget5 = AddToggleOption("Toggle Follower Counter", Follower5Script.Visible)
		FollowerPosX5 = AddSliderOption("Left/Right-Position", Follower5Script.X, "{0}")
		FollowerPosY5 = AddSliderOption("Up/Down-Position", Follower5Script.Y, "{0}")
		FollowerAnchorV5 = AddMenuOption("Vertical-Anchor", VAnchorFollowerString5[VAnchorFollowerString5.Find(Follower5Script.VAnchor)])		
		FollowerAnchorH5 = AddMenuOption("Horizontal-Anchor", HAnchorFollowerString5[HAnchorFollowerString5.Find(Follower5Script.HAnchor)])
		FollowerAlpha5 = AddSliderOption("Transparency", Follower5Script.Alpha, "{0} %")
		FollowerScale5 = AddSliderOption("Scale", Follower5Script.Size, "{0} %")
	EndIf

EndEvent

Event OnOptionHighlight(int Option)

	If (Option == BumpTime)
		SetInfoText("Enable Followers responding better if they stand in your way and you bump into them! Default: off")
	ElseIf (Option == WeapDraw)
		SetInfoText("Toggle Followers not drawing weapons with you! Default: off")		
	ElseIf (Option == ResetAll)
		SetInfoText("Reset all Hotkeys!")
	ElseIf (Option == KeyQuickTrade)
		SetInfoText("Define your Follower Trade Hotkey!")
	ElseIf (Option == KeyQuickCommand)
		SetInfoText("Define your Follower Command Hotkey!")
	ElseIf (Option == KeyQuickSummon)
		SetInfoText("Define a Hotkey to call/summon your follower!")
	ElseIf (Option == KeyQuickRelax)
		SetInfoText("Define a Hotkey to send your Follower relaxing!")
	ElseIf (Option == KeyQuickAvoid)
		SetInfoText("Define a Hotkey to tell your Follower to avoid combat!")
	ElseIf (Option == KeyQuickLookBack)
		SetInfoText("Define a Hotkey to change camera to Follower!")
	ElseIf (Option == KeyQuickDrawWeapon)
		SetInfoText("Define a Hotkey to make your Follower draw his/her weapon!")
	Elseif option == CStyle1
		SetInfoText("Choose Combat Style for this Follower!")
	Elseif option == CStyle2
		SetInfoText("Choose Combat Style for this Follower!")
	Elseif option == CStyle3
		SetInfoText("Choose Combat Style for this Follower!")
	Elseif option == CStyle4
		SetInfoText("Choose Combat Style for this Follower!")
	Elseif option == CStyle5
		SetInfoText("Choose Combat Style for this Follower!")		
	ElseIf (Option == CarryWeightPointsFollower1)
		SetInfoText("Set Follower Base Carry Weight on first Follower!")
	ElseIf (Option == CarryWeightPointsFollower2)
		SetInfoText("Set Follower Base Carry Weight on second Follower!")
	ElseIf (Option == CarryWeightPointsFollower3)
		SetInfoText("Set Follower Base Carry Weight on third Follower!")
	ElseIf (Option == CarryWeightPointsFollower4)
		SetInfoText("Set Follower Base Carry Weight on third Follower!")
	ElseIf (Option == CarryWeightPointsFollower5)
		SetInfoText("Set Follower Base Carry Weight on third Follower!")		
	ElseIf (Option == SpeedPointsFollower1)
		SetInfoText("Set First Follower Base Speed Multiplier!")
	ElseIf (Option == SpeedPointsFollower2)
		SetInfoText("Set Second Follower Base Speed Multiplier!")
	ElseIf (Option == SpeedPointsFollower3)
		SetInfoText("Set Third Follower Base Speed Multiplier!")
	ElseIf (Option == SpeedPointsFollower4)
		SetInfoText("Set Fourth Follower Base Speed Multiplier!")
	ElseIf (Option == SpeedPointsFollower5)
		SetInfoText("Set Fifth Follower Base Speed Multiplier!")
	ElseIf (Option == AggressionFollower1)
		SetInfoText("Set First Follower Aggression! 0 = Unaggressive, 1 = Aggressive!")
	ElseIf (Option == AggressionFollower2)
		SetInfoText("Set Second Follower Aggression! 0 = Unaggressive, 1 = Aggressive!")
	ElseIf (Option == AggressionFollower3)
		SetInfoText("Set Third Follower Aggression! 0 = Unaggressive, 1 = Aggressive!")
	ElseIf (Option == AggressionFollower4)
		SetInfoText("Set Fourth Follower Aggression! 0 = Unaggressive, 1 = Aggressive!")
	ElseIf (Option == AggressionFollower5)
		SetInfoText("Set Fifth Follower Aggression! 0 = Unaggressive, 1 = Aggressive!")
	ElseIf (Option == ConfidenceFollower1)
		SetInfoText("Set First Follower Confidence! 0 = Coward, 4 = Foolhard!")
	ElseIf (Option == ConfidenceFollower2)
		SetInfoText("Set Second Follower Confidence! 0 = Coward, 4 = Foolhard!")
	ElseIf (Option == ConfidenceFollower3)
		SetInfoText("Set Third Follower Confidence! 0 = Coward, 4 = Foolhard!")
	ElseIf (Option == ConfidenceFollower4)
		SetInfoText("Set Fourth Follower Confidence! 0 = Coward, 4 = Foolhard!")
	ElseIf (Option == ConfidenceFollower5)
		SetInfoText("Set Fifth Follower Confidence! 0 = Coward, 4 = Foolhard!")
	ElseIf (Option == AssistanceFollower1)
		SetInfoText("Set First Follower Assistance! 0 = Helps no One, 2 = Helps Anyone!")
	ElseIf (Option == AssistanceFollower2)
		SetInfoText("Set Second Follower Assistance! 0 = Helps no One, 2 = Helps Anyone!")
	ElseIf (Option == AssistanceFollower3)
		SetInfoText("Set Third Follower Assistance! 0 = Helps no One, 2 = Helps Anyone!")
	ElseIf (Option == AssistanceFollower4)
		SetInfoText("Set Fourth Follower Assistance! 0 = Helps no One, 2 = Helps Anyone!")
	ElseIf (Option == AssistanceFollower5)
		SetInfoText("Set Fifth Follower Assistance! 0 = Helps no One, 2 = Helps Anyone!")
	ElseIf (Option == MoralityFollower1)
		SetInfoText("Set First Follower Morality! 0 = Commits any Crime, 3 = Commits no Crime!")
	ElseIf (Option == MoralityFollower2)
		SetInfoText("Set Second Follower Morality! 0 = Commits any Crime, 3 = Commits no Crime!")
	ElseIf (Option == MoralityFollower3)
		SetInfoText("Set Third Follower Morality! 0 = Commits any Crime, 3 = Commits no Crime!")
	ElseIf (Option == MoralityFollower4)
		SetInfoText("Set Fourth Follower Morality! 0 = Commits any Crime, 3 = Commits no Crime!")
	ElseIf (Option == MoralityFollower5)
		SetInfoText("Set Fifth Follower Morality! 0 = Commits any Crime, 3 = Commits no Crime!")
	ElseIf (Option == FollowerWidget1)
		SetInfoText("Turn on/off Follower Counter! Default: on")
	ElseIf (Option == FollowerPosX1)
		SetInfoText("Set the horizontal position of the Follower Widget!")
	ElseIf (Option == FollowerPosY1)
		SetInfoText("Set the vertical position of the Follower Widget!")
	ElseIf (Option == FollowerAnchorH1)
		SetInfoText("Set the horizontal anchor of the Follower Widget! Used for faster replacement ")
	ElseIf (Option == FollowerAnchorV1)
		SetInfoText("Set the vertical anchor of the Follower Widget! Used for faster replacement ")	
	ElseIf (Option == FollowerAlpha1)
		SetInfoText("Set the transparency of the Follower Widget!")
	ElseIf (Option == FollowerScale1)
		SetInfoText("Set the size of the Follower Widget!")	
	ElseIf (Option == FollowerWidget2)
		SetInfoText("Turn on/off Follower Counter! Default: on")
	ElseIf (Option == FollowerPosX2)
		SetInfoText("Set the horizontal position of the Follower Widget!")
	ElseIf (Option == FollowerPosY2)
		SetInfoText("Set the vertical position of the Follower Widget!")
	ElseIf (Option == FollowerAnchorH2)
		SetInfoText("Set the horizontal anchor of the Follower Widget! Used for faster replacement ")
	ElseIf (Option == FollowerAnchorV2)
		SetInfoText("Set the vertical anchor of the Follower Widget! Used for faster replacement ")	
	ElseIf (Option == FollowerAlpha2)
		SetInfoText("Set the transparency of the Follower Widget!")
	ElseIf (Option == FollowerScale2)
		SetInfoText("Set the size of the Follower Widget!")
	ElseIf (Option == FollowerWidget3)
		SetInfoText("Turn on/off Follower Counter! Default: on")
	ElseIf (Option == FollowerPosX3)
		SetInfoText("Set the horizontal position of the Follower Widget!")
	ElseIf (Option == FollowerPosY3)
		SetInfoText("Set the vertical position of the Follower Widget!")
	ElseIf (Option == FollowerAnchorH3)
		SetInfoText("Set the horizontal anchor of the Follower Widget! Used for faster replacement ")
	ElseIf (Option == FollowerAnchorV3)
		SetInfoText("Set the vertical anchor of the Follower Widget! Used for faster replacement ")	
	ElseIf (Option == FollowerAlpha3)
		SetInfoText("Set the transparency of the Follower Widget!")
	ElseIf (Option == FollowerScale3)
		SetInfoText("Set the size of the Follower Widget!")	
	ElseIf (Option == FollowerWidget4)
		SetInfoText("Turn on/off Follower Counter! Default: on")
	ElseIf (Option == FollowerPosX4)
		SetInfoText("Set the horizontal position of the Follower Widget!")
	ElseIf (Option == FollowerPosY4)
		SetInfoText("Set the vertical position of the Follower Widget!")
	ElseIf (Option == FollowerAnchorH4)
		SetInfoText("Set the horizontal anchor of the Follower Widget! Used for faster replacement ")
	ElseIf (Option == FollowerAnchorV4)
		SetInfoText("Set the vertical anchor of the Follower Widget! Used for faster replacement ")	
	ElseIf (Option == FollowerAlpha4)
		SetInfoText("Set the transparency of the Follower Widget!")
	ElseIf (Option == FollowerScale4)
		SetInfoText("Set the size of the Follower Widget!")	
	ElseIf (Option == FollowerWidget5)
		SetInfoText("Turn on/off Follower Counter! Default: on")
	ElseIf (Option == FollowerPosX5)
		SetInfoText("Set the horizontal position of the Follower Widget!")
	ElseIf (Option == FollowerPosY5)
		SetInfoText("Set the vertical position of the Follower Widget!")
	ElseIf (Option == FollowerAnchorH5)
		SetInfoText("Set the horizontal anchor of the Follower Widget! Used for faster replacement ")
	ElseIf (Option == FollowerAnchorV5)
		SetInfoText("Set the vertical anchor of the Follower Widget! Used for faster replacement ")	
	ElseIf (Option == FollowerAlpha5)
		SetInfoText("Set the transparency of the Follower Widget!")
	ElseIf (Option == FollowerScale5)
		SetInfoText("Set the size of the Follower Widget!")
	ElseIf (Option == UpdateTimerInt)
		SetInfoText("Set the interval of the update script in seconds!")
	ElseIf (Option == FissLoad)
		SetInfoText("Load user preset from .xml!")
	ElseIf (Option == FissSave)
		SetInfoText("Save user preset to .xml!")		
	EndIf

EndEvent

Event OnOptionSelect(int Option)

	If (Option == BumpTime)
		BumpTimeToggle = !BumpTimeToggle
		SetToggleOptionValue(BumpTime, BumpTimeToggle)
		Game.SetGameSettingFloat("fBumpReactionIdealMoveDist", 250.000000)
		Game.SetGameSettingFloat("fBumpReactionMinMoveDist", 250.000000)
		Game.SetGameSettingFloat("fBumpReactionSmallDelayTime", 0.500000)
		Game.SetGameSettingFloat("fBumpReactionSmallWaitTimer", 0.500000)		
		If !BumpTimeToggle
			Game.SetGameSettingFloat("fBumpReactionIdealMoveDist", 125.000000)
			Game.SetGameSettingFloat("fBumpReactionMinMoveDist", 75.000000)
			Game.SetGameSettingFloat("fBumpReactionSmallDelayTime", 1.000000)
			Game.SetGameSettingFloat("fBumpReactionSmallWaitTimer", 3.000000)		
		EndIf
	ElseIf (Option == WeapDraw)
		WeapDrawToggle = !WeapDrawToggle
		SetToggleOptionValue(WeapDraw, WeapDrawToggle)
		Game.SetGameSettingFloat("fAIDistanceTeammateDrawWeapon", 0.000000)		
		If !WeapDrawToggle
			Game.SetGameSettingFloat("fAIDistanceTeammateDrawWeapon", 2000.000000)	
		EndIf		
	ElseIf (Option == ResetAll)
		SetKeymapOptionValue(KeyTrade, 0)
		SetKeymapOptionValue(KeyCommand, 0)
		SetKeymapOptionValue(KeySummon, 0)
		SetKeymapOptionValue(KeyRelax, 0)
		SetKeymapOptionValue(KeyAvoid, 0)
		SetKeymapOptionValue(KeyLookBack, 0)
		SetKeymapOptionValue(KeyDrawWeapon, 0)	
		UnregisterForKey(KeyTrade)
		UnregisterForKey(KeyCommand)
		UnregisterForKey(KeySummon)
		UnregisterForKey(KeyRelax)
		UnregisterForKey(KeyAvoid)		
		UnregisterForKey(KeyLookBack)
		UnregisterForKey(KeyDrawWeapon)	
	ElseIf (Option == FollowerWidget1)
		Follower1Script.Visible = !Follower1Script.Visible
		SetToggleOptionValue(Option, Follower1Script.Visible)
	ElseIf (Option == FollowerWidget2)
		Follower2Script.Visible = !Follower2Script.Visible
		SetToggleOptionValue(Option, Follower2Script.Visible)
	ElseIf (Option == FollowerWidget3)
		Follower3Script.Visible = !Follower3Script.Visible
		SetToggleOptionValue(Option, Follower3Script.Visible)
	ElseIf (Option == FollowerWidget4)
		Follower4Script.Visible = !Follower4Script.Visible
		SetToggleOptionValue(Option, Follower4Script.Visible)
	ElseIf (Option == FollowerWidget5)
		Follower5Script.Visible = !Follower5Script.Visible
		SetToggleOptionValue(Option, Follower5Script.Visible)
	ElseIf (Option == FissLoad)
		FISSInterface fiss = FISSFactory.getFISS()
		If fiss
			fiss.beginLoad("FMUserSettings.xml")		
			SetTextOptionValue(Option, "Done!")
			LoadUserPreset()
		Else
			Debug.Messagebox("FISS not found, load aborted!")
		EndIf	
	ElseIf (Option == FissSave)
		FISSInterface fiss = FISSFactory.getFISS()
		fiss.beginLoad("FMUserSettings.xml")		
		If fiss
			SetTextOptionValue(Option, "Done!")
			SaveUserPreset()
		Else
			Debug.Messagebox("FISS not found, save aborted!")
		EndIf		
	EndIf

EndEvent

Event OnOptionSliderOpen(int Option)

	If (Option == CarryWeightPointsFollower1)
		SetSliderDialogStartValue(CarryWeightPointsFollowerSlider1)
		SetSliderDialogDefaultValue(300.00)
		SetSliderDialogRange(0.00, 1000.00)
		SetSliderDialogInterval(1.00)
	ElseIf (Option == CarryWeightPointsFollower2)
		SetSliderDialogStartValue(CarryWeightPointsFollowerSlider2)
		SetSliderDialogDefaultValue(300.00)
		SetSliderDialogRange(0.00, 1000.00)
		SetSliderDialogInterval(1.00)
	ElseIf (Option == CarryWeightPointsFollower3)
		SetSliderDialogStartValue(CarryWeightPointsFollowerSlider3)
		SetSliderDialogDefaultValue(300.00)
		SetSliderDialogRange(0.00, 1000.00)
		SetSliderDialogInterval(1.00)
	ElseIf (Option == CarryWeightPointsFollower4)
		SetSliderDialogStartValue(CarryWeightPointsFollowerSlider4)
		SetSliderDialogDefaultValue(300.00)
		SetSliderDialogRange(0.00, 1000.00)
		SetSliderDialogInterval(1.00)
	ElseIf (Option == CarryWeightPointsFollower5)
		SetSliderDialogStartValue(CarryWeightPointsFollowerSlider5)
		SetSliderDialogDefaultValue(300.00)
		SetSliderDialogRange(0.00, 1000.00)
		SetSliderDialogInterval(1.00)
	ElseIf (Option == SpeedPointsFollower1)
		SetSliderDialogStartValue(SpeedPointsFollowerSlider1)
		SetSliderDialogDefaultValue(100.00)
		SetSliderDialogRange(50.00, 150.00)
		SetSliderDialogInterval(1.00)
	ElseIf (Option == SpeedPointsFollower2)
		SetSliderDialogStartValue(SpeedPointsFollowerSlider2)
		SetSliderDialogDefaultValue(100.00)
		SetSliderDialogRange(50.00, 150.00)
		SetSliderDialogInterval(1.00)
	ElseIf (Option == SpeedPointsFollower3)
		SetSliderDialogStartValue(SpeedPointsFollowerSlider3)
		SetSliderDialogDefaultValue(100.00)
		SetSliderDialogRange(50.00, 150.00)
		SetSliderDialogInterval(1.00)
	ElseIf (Option == SpeedPointsFollower4)
		SetSliderDialogStartValue(SpeedPointsFollowerSlider4)
		SetSliderDialogDefaultValue(100.00)
		SetSliderDialogRange(50.00, 150.00)
		SetSliderDialogInterval(1.00)
	ElseIf (Option == SpeedPointsFollower5)
		SetSliderDialogStartValue(SpeedPointsFollowerSlider5)
		SetSliderDialogDefaultValue(100.00)
		SetSliderDialogRange(50.00, 150.00)
		SetSliderDialogInterval(1.00)
	ElseIf (Option == AggressionFollower1)
		SetSliderDialogStartValue(FollowerAggressionSlider1)
		SetSliderDialogDefaultValue(1.00)
		SetSliderDialogRange(0.00, 1.00)
		SetSliderDialogInterval(1.00)
	ElseIf (Option == AggressionFollower2)
		SetSliderDialogStartValue(FollowerAggressionSlider2)
		SetSliderDialogDefaultValue(1.00)
		SetSliderDialogRange(0.00, 1.00)
		SetSliderDialogInterval(1.00)
	ElseIf (Option == AggressionFollower3)
		SetSliderDialogStartValue(FollowerAggressionSlider3)
		SetSliderDialogDefaultValue(1.00)
		SetSliderDialogRange(0.00, 1.00)
		SetSliderDialogInterval(1.00)
	ElseIf (Option == AggressionFollower4)
		SetSliderDialogStartValue(FollowerAggressionSlider4)
		SetSliderDialogDefaultValue(1.00)
		SetSliderDialogRange(0.00, 1.00)
		SetSliderDialogInterval(1.00)
	ElseIf (Option == AggressionFollower5)
		SetSliderDialogStartValue(FollowerAggressionSlider5)
		SetSliderDialogDefaultValue(1.00)
		SetSliderDialogRange(0.00, 1.00)
		SetSliderDialogInterval(1.00)
	ElseIf (Option == ConfidenceFollower1)
		SetSliderDialogStartValue(FollowerConfidenceSlider1)
		SetSliderDialogDefaultValue(4.00)
		SetSliderDialogRange(0.00, 4.00)
		SetSliderDialogInterval(1.00)
	ElseIf (Option == ConfidenceFollower2)
		SetSliderDialogStartValue(FollowerConfidenceSlider2)
		SetSliderDialogDefaultValue(4.00)
		SetSliderDialogRange(0.00, 4.00)
		SetSliderDialogInterval(1.00)
	ElseIf (Option == ConfidenceFollower3)
		SetSliderDialogStartValue(FollowerConfidenceSlider3)
		SetSliderDialogDefaultValue(4.00)
		SetSliderDialogRange(0.00, 4.00)
		SetSliderDialogInterval(1.00)
	ElseIf (Option == ConfidenceFollower4)
		SetSliderDialogStartValue(FollowerConfidenceSlider4)
		SetSliderDialogDefaultValue(4.00)
		SetSliderDialogRange(0.00, 4.00)
		SetSliderDialogInterval(1.00)
	ElseIf (Option == ConfidenceFollower5)
		SetSliderDialogStartValue(FollowerConfidenceSlider5)
		SetSliderDialogDefaultValue(4.00)
		SetSliderDialogRange(0.00, 4.00)
		SetSliderDialogInterval(1.00)
	ElseIf (Option == AssistanceFollower1)
		SetSliderDialogStartValue(FollowerAssistanceSlider1)
		SetSliderDialogDefaultValue(2.00)
		SetSliderDialogRange(0.00, 2.00)
		SetSliderDialogInterval(1.00)
	ElseIf (Option == AssistanceFollower2)
		SetSliderDialogStartValue(FollowerAssistanceSlider2)
		SetSliderDialogDefaultValue(2.00)
		SetSliderDialogRange(0.00, 2.00)
		SetSliderDialogInterval(1.00)
	ElseIf (Option == AssistanceFollower3)
		SetSliderDialogStartValue(FollowerAssistanceSlider3)
		SetSliderDialogDefaultValue(2.00)
		SetSliderDialogRange(0.00, 2.00)
		SetSliderDialogInterval(1.00)
	ElseIf (Option == AssistanceFollower4)
		SetSliderDialogStartValue(FollowerAssistanceSlider4)
		SetSliderDialogDefaultValue(2.00)
		SetSliderDialogRange(0.00, 2.00)
		SetSliderDialogInterval(1.00)
	ElseIf (Option == AssistanceFollower5)
		SetSliderDialogStartValue(FollowerAssistanceSlider5)
		SetSliderDialogDefaultValue(2.00)
		SetSliderDialogRange(0.00, 2.00)
		SetSliderDialogInterval(1.00)
	ElseIf (Option == MoralityFollower1)
		SetSliderDialogStartValue(FollowerMoralitySlider1)
		SetSliderDialogDefaultValue(3.00)
		SetSliderDialogRange(0.00, 3.00)
		SetSliderDialogInterval(1.00)
	ElseIf (Option == MoralityFollower2)
		SetSliderDialogStartValue(FollowerMoralitySlider2)
		SetSliderDialogDefaultValue(3.00)
		SetSliderDialogRange(0.00, 3.00)
		SetSliderDialogInterval(1.00)
	ElseIf (Option == MoralityFollower3)
		SetSliderDialogStartValue(FollowerMoralitySlider3)
		SetSliderDialogDefaultValue(3.00)
		SetSliderDialogRange(0.00, 3.00)
		SetSliderDialogInterval(1.00)
	ElseIf (Option == MoralityFollower4)
		SetSliderDialogStartValue(FollowerMoralitySlider4)
		SetSliderDialogDefaultValue(3.00)
		SetSliderDialogRange(0.00, 3.00)
		SetSliderDialogInterval(1.00)
	ElseIf (Option == MoralityFollower5)
		SetSliderDialogStartValue(FollowerMoralitySlider5)
		SetSliderDialogDefaultValue(3.00)
		SetSliderDialogRange(0.00, 3.00)
		SetSliderDialogInterval(1.00)
	ElseIf (Option == FollowerPosX1)
		SetSliderDialogStartValue(Follower1Script.X)
		SetSliderDialogRange(-100.00, 1380.00)
		SetSliderDialogInterval(1.00)
		SetSliderDialogDefaultValue(165.00)
	ElseIf (Option == FollowerPosY1)
		SetSliderDialogStartValue(Follower1Script.Y)
		SetSliderDialogRange(-100.00, 820.00)
		SetSliderDialogInterval(1.00)
		SetSliderDialogDefaultValue(712.00)	
	ElseIf (Option == FollowerPosX2)
		SetSliderDialogStartValue(Follower2Script.X)
		SetSliderDialogRange(-100.00, 1380.00)
		SetSliderDialogInterval(1.00)
		SetSliderDialogDefaultValue(165.00)
	ElseIf (Option == FollowerPosY2)
		SetSliderDialogStartValue(Follower2Script.Y)
		SetSliderDialogRange(-100.00, 820.00)
		SetSliderDialogInterval(1.00)
		SetSliderDialogDefaultValue(712.00)
	ElseIf (Option == FollowerPosX3)
		SetSliderDialogStartValue(Follower3Script.X)
		SetSliderDialogRange(-100.00, 1380.00)
		SetSliderDialogInterval(1.00)
		SetSliderDialogDefaultValue(165.00)
	ElseIf (Option == FollowerPosY3)
		SetSliderDialogStartValue(Follower3Script.Y)
		SetSliderDialogRange(-100.00, 820.00)
		SetSliderDialogInterval(1.00)
		SetSliderDialogDefaultValue(712.00)
	ElseIf (Option == FollowerPosX4)
		SetSliderDialogStartValue(Follower4Script.X)
		SetSliderDialogRange(-100.00, 1380.00)
		SetSliderDialogInterval(1.00)
		SetSliderDialogDefaultValue(165.00)
	ElseIf (Option == FollowerPosY4)
		SetSliderDialogStartValue(Follower4Script.Y)
		SetSliderDialogRange(-100.00, 820.00)
		SetSliderDialogInterval(1.00)
		SetSliderDialogDefaultValue(712.00)
	ElseIf (Option == FollowerPosX5)
		SetSliderDialogStartValue(Follower5Script.X)
		SetSliderDialogRange(-100.00, 1380.00)
		SetSliderDialogInterval(1.00)
		SetSliderDialogDefaultValue(165.00)
	ElseIf (Option == FollowerPosY5)
		SetSliderDialogStartValue(Follower5Script.Y)
		SetSliderDialogRange(-100.00, 820.00)
		SetSliderDialogInterval(1.00)
		SetSliderDialogDefaultValue(712.00)
	ElseIf (Option == FollowerAlpha1)
		SetSliderDialogStartValue(Follower1Script.Alpha)
		SetSliderDialogRange(0.00, 100.00)
		SetSliderDialogInterval(1.00)
		SetSliderDialogDefaultValue(100.00)
	ElseIf (Option == FollowerAlpha2)
		SetSliderDialogStartValue(Follower2Script.Alpha)
		SetSliderDialogRange(0.00, 100.00)
		SetSliderDialogInterval(1.00)
		SetSliderDialogDefaultValue(100.00)
	ElseIf (Option == FollowerAlpha3)
		SetSliderDialogStartValue(Follower3Script.Alpha)
		SetSliderDialogRange(0.00, 100.00)
		SetSliderDialogInterval(1.00)
		SetSliderDialogDefaultValue(100.00)	
	ElseIf (Option == FollowerAlpha4)
		SetSliderDialogStartValue(Follower4Script.Alpha)
		SetSliderDialogRange(0.00, 100.00)
		SetSliderDialogInterval(1.00)
		SetSliderDialogDefaultValue(100.00)
	ElseIf (Option == FollowerAlpha5)
		SetSliderDialogStartValue(Follower5Script.Alpha)
		SetSliderDialogRange(0.00, 100.00)
		SetSliderDialogInterval(1.00)
		SetSliderDialogDefaultValue(100.00)
	ElseIf (Option == FollowerScale1)
		SetSliderDialogStartValue(Follower1Script.Size)
		SetSliderDialogRange(1.00, 1000.00)
		SetSliderDialogInterval(1.00)
		SetSliderDialogDefaultValue(100.00)
	ElseIf (Option == FollowerScale2)
		SetSliderDialogStartValue(Follower2Script.Size)
		SetSliderDialogRange(1.00, 1000.00)
		SetSliderDialogInterval(1.00)
		SetSliderDialogDefaultValue(100.00)
	ElseIf (Option == FollowerScale3)
		SetSliderDialogStartValue(Follower3Script.Size)
		SetSliderDialogRange(1.00, 1000.00)
		SetSliderDialogInterval(1.00)
		SetSliderDialogDefaultValue(100.00)
	ElseIf (Option == FollowerScale4)
		SetSliderDialogStartValue(Follower4Script.Size)
		SetSliderDialogRange(1.00, 1000.00)
		SetSliderDialogInterval(1.00)
		SetSliderDialogDefaultValue(100.00)
	ElseIf (Option == FollowerScale5)
		SetSliderDialogStartValue(Follower5Script.Size)
		SetSliderDialogRange(1.00, 1000.00)
		SetSliderDialogInterval(1.00)
		SetSliderDialogDefaultValue(100.00)
	ElseIf (Option == UpdateTimerInt)
		SetSliderDialogStartValue(UpdateScript.UpdateTimer)
		SetSliderDialogRange(0.1, 10.00)
		SetSliderDialogInterval(0.1)
		SetSliderDialogDefaultValue(0.25)		
	EndIf

EndEvent

Event OnOptionSliderAccept(int Option, float Value)

	If (Option == CarryWeightPointsFollower1)
		CarryWeightPointsFollowerSlider1 = Value
		SetSliderOptionValue(CarryWeightPointsFollower1, CarryWeightPointsFollowerSlider1, "{1}")
		If AliasArray[0] != none
			AliasArray[0].GetActorReference().SetActorValue("CarryWeight", Value)
		ElseIf AliasArray[0] == none
		EndIf
	ElseIf (Option == CarryWeightPointsFollower2)
		CarryWeightPointsFollowerSlider2 = Value
		SetSliderOptionValue(CarryWeightPointsFollower2, CarryWeightPointsFollowerSlider2, "{1}")
		If AliasArray[1] != none
			AliasArray[1].GetActorReference().SetActorValue("CarryWeight", Value)
		ElseIf AliasArray[1] == none
		EndIf
	ElseIf (Option == CarryWeightPointsFollower3)
		CarryWeightPointsFollowerSlider3 = Value
		SetSliderOptionValue(CarryWeightPointsFollower3, CarryWeightPointsFollowerSlider3, "{1}")
		If AliasArray[2] != none
			AliasArray[2].GetActorReference().SetActorValue("CarryWeight", Value)
		ElseIf AliasArray[2] == none
		EndIf
	ElseIf (Option == CarryWeightPointsFollower4)
		CarryWeightPointsFollowerSlider4 = Value
		SetSliderOptionValue(CarryWeightPointsFollower4, CarryWeightPointsFollowerSlider4, "{1}")
		If AliasArray[3] != none
			AliasArray[3].GetActorReference().SetActorValue("CarryWeight", Value)
		ElseIf AliasArray[3] == none
		EndIf
	ElseIf (Option == CarryWeightPointsFollower5)
		CarryWeightPointsFollowerSlider5 = Value
		SetSliderOptionValue(CarryWeightPointsFollower5, CarryWeightPointsFollowerSlider5, "{1}")
		If AliasArray[4] != none
			AliasArray[4].GetActorReference().SetActorValue("CarryWeight", Value)
		ElseIf AliasArray[4] == none
		EndIf
	ElseIf (Option == SpeedPointsFollower1)
		SpeedPointsFollowerSlider1 = Value
		SetSliderOptionValue(SpeedPointsFollower1, SpeedPointsFollowerSlider1, "{1}")
		If AliasArray[0] != none
			AliasArray[0].GetActorReference().SetActorValue("SpeedMult", Value)
		ElseIf AliasArray[0] == none
		EndIf
	ElseIf (Option == SpeedPointsFollower2)
		SpeedPointsFollowerSlider2 = Value
		SetSliderOptionValue(SpeedPointsFollower2, SpeedPointsFollowerSlider2, "{1}")
		If AliasArray[1] != none
			AliasArray[1].GetActorReference().SetActorValue("SpeedMult", Value)
		ElseIf AliasArray[1] == none
		EndIf
	ElseIf (Option == SpeedPointsFollower3)
		SpeedPointsFollowerSlider3 = Value
		SetSliderOptionValue(SpeedPointsFollower3, SpeedPointsFollowerSlider3, "{1}")
		If AliasArray[2] != none
			AliasArray[2].GetActorReference().SetActorValue("SpeedMult", Value)
		ElseIf AliasArray[2] == none
		EndIf
	ElseIf (Option == SpeedPointsFollower4)
		SpeedPointsFollowerSlider4 = Value
		SetSliderOptionValue(SpeedPointsFollower4, SpeedPointsFollowerSlider4, "{1}")
		If AliasArray[3] != none
			AliasArray[3].GetActorReference().SetActorValue("SpeedMult", Value)
		ElseIf AliasArray[3] == none
		EndIf
	ElseIf (Option == SpeedPointsFollower5)
		SpeedPointsFollowerSlider5 = Value
		SetSliderOptionValue(SpeedPointsFollower5, SpeedPointsFollowerSlider5, "{1}")
		If AliasArray[4] != none
			AliasArray[4].GetActorReference().SetActorValue("SpeedMult", Value)
		ElseIf AliasArray[4] == none
		EndIf
	ElseIf (Option == AggressionFollower1)
		FollowerAggressionSlider1 = Value
		SetSliderOptionValue(AggressionFollower1, FollowerAggressionSlider1, "{1}")
		If AliasArray[0]  != none
			AliasArray[0].GetActorReference().SetActorValue("Aggression", Value)
		ElseIf AliasArray[0] == none
		EndIf
	ElseIf (Option == AggressionFollower2)
		FollowerAggressionSlider2 = Value
		SetSliderOptionValue(AggressionFollower2, FollowerAggressionSlider2, "{1}")
		If AliasArray[1]  != none
			AliasArray[1].GetActorReference().SetActorValue("Aggression", Value)
		ElseIf AliasArray[1] == none
		EndIf
	ElseIf (Option == AggressionFollower3)
		FollowerAggressionSlider3 = Value
		SetSliderOptionValue(AggressionFollower3, FollowerAggressionSlider3, "{1}")
		If AliasArray[2]  != none
			AliasArray[2].GetActorReference().SetActorValue("Aggression", Value)
		ElseIf AliasArray[2] == none
		EndIf
	ElseIf (Option == AggressionFollower4)
		FollowerAggressionSlider4 = Value
		SetSliderOptionValue(AggressionFollower4, FollowerAggressionSlider4, "{1}")
		If AliasArray[3]  != none
			AliasArray[3].GetActorReference().SetActorValue("Aggression", Value)
		ElseIf AliasArray[3] == none
		EndIf
	ElseIf (Option == AggressionFollower5)
		FollowerAggressionSlider5 = Value
		SetSliderOptionValue(AggressionFollower5, FollowerAggressionSlider5, "{1}")
		If AliasArray[4]  != none
			AliasArray[4].GetActorReference().SetActorValue("Aggression", Value)
		ElseIf AliasArray[4] == none
		EndIf
	ElseIf (Option == ConfidenceFollower1)
		FollowerConfidenceSlider1 = Value
		SetSliderOptionValue(ConfidenceFollower1, FollowerConfidenceSlider1, "{1}")
		If AliasArray[0] != none		
			AliasArray[0].GetActorReference().SetActorValue("Confidence", Value)
		ElseIf AliasArray[0] == none
		EndIf
	ElseIf (Option == ConfidenceFollower2)
		FollowerConfidenceSlider2 = Value
		SetSliderOptionValue(ConfidenceFollower2, FollowerConfidenceSlider2, "{1}")
		If AliasArray[1] != none		
			AliasArray[1].GetActorReference().SetActorValue("Confidence", Value)
		ElseIf AliasArray[1] == none
		EndIf
	ElseIf (Option == ConfidenceFollower3)
		FollowerConfidenceSlider3 = Value
		SetSliderOptionValue(ConfidenceFollower3, FollowerConfidenceSlider3, "{1}")
		If AliasArray[2] != none		
			AliasArray[2].GetActorReference().SetActorValue("Confidence", Value)
		ElseIf AliasArray[2] == none
		EndIf
	ElseIf (Option == ConfidenceFollower4)
		FollowerConfidenceSlider4 = Value
		SetSliderOptionValue(ConfidenceFollower4, FollowerConfidenceSlider4, "{1}")
		If AliasArray[3] != none		
			AliasArray[3].GetActorReference().SetActorValue("Confidence", Value)
		ElseIf AliasArray[3] == none
		EndIf
	ElseIf (Option == ConfidenceFollower5)
		FollowerConfidenceSlider5 = Value
		SetSliderOptionValue(ConfidenceFollower5, FollowerConfidenceSlider5, "{1}")
		If AliasArray[4] != none		
			AliasArray[4].GetActorReference().SetActorValue("Confidence", Value)
		ElseIf AliasArray[4] == none
		EndIf
	ElseIf (Option == AssistanceFollower1)
		FollowerAssistanceSlider1 = Value
		SetSliderOptionValue(AssistanceFollower1, FollowerAssistanceSlider1, "{1}")
		If AliasArray[0] != none		
			AliasArray[0].GetActorReference().SetActorValue("Assistance", Value)
		ElseIf AliasArray[0] == none
		EndIf
	ElseIf (Option == AssistanceFollower2)
		FollowerAssistanceSlider2 = Value
		SetSliderOptionValue(AssistanceFollower2, FollowerAssistanceSlider2, "{1}")
		If AliasArray[1] != none		
			AliasArray[1].GetActorReference().SetActorValue("Assistance", Value)
		ElseIf AliasArray[1] == none
		EndIf
	ElseIf (Option == AssistanceFollower3)
		FollowerAssistanceSlider3 = Value
		SetSliderOptionValue(AssistanceFollower3, FollowerAssistanceSlider3, "{1}")
		If AliasArray[2] != none		
			AliasArray[2].GetActorReference().SetActorValue("Assistance", Value)
		ElseIf AliasArray[2] == none
		EndIf
	ElseIf (Option == AssistanceFollower4)
		FollowerAssistanceSlider4 = Value
		SetSliderOptionValue(AssistanceFollower4, FollowerAssistanceSlider4, "{1}")
		If AliasArray[3] != none		
			AliasArray[3].GetActorReference().SetActorValue("Assistance", Value)
		ElseIf AliasArray[3] == none
		EndIf
	ElseIf (Option == AssistanceFollower5)
		FollowerAssistanceSlider5 = Value
		SetSliderOptionValue(AssistanceFollower5, FollowerAssistanceSlider5, "{1}")
		If AliasArray[4] != none		
			AliasArray[4].GetActorReference().SetActorValue("Assistance", Value)
		ElseIf AliasArray[4] == none
		EndIf
	ElseIf (Option == MoralityFollower1)
		FollowerMoralitySlider1 = Value
		SetSliderOptionValue(MoralityFollower1, FollowerMoralitySlider1, "{1}")
		If AliasArray[0] != none		
			AliasArray[0].GetActorReference().SetActorValue("Morality", Value)
		ElseIf AliasArray[0] == none
		EndIf
	ElseIf (Option == MoralityFollower2)
		FollowerMoralitySlider2 = Value
		SetSliderOptionValue(MoralityFollower2, FollowerMoralitySlider2, "{1}")
		If AliasArray[1] != none		
			AliasArray[1].GetActorReference().SetActorValue("Morality", Value)
		ElseIf AliasArray[1] == none
		EndIf
	ElseIf (Option == MoralityFollower3)
		FollowerMoralitySlider3 = Value
		SetSliderOptionValue(MoralityFollower3, FollowerMoralitySlider3, "{1}")
		If AliasArray[2] != none		
			AliasArray[2].GetActorReference().SetActorValue("Morality", Value)
		ElseIf AliasArray[2] == none
		EndIf
	ElseIf (Option == MoralityFollower4)
		FollowerMoralitySlider4 = Value
		SetSliderOptionValue(MoralityFollower4, FollowerMoralitySlider4, "{1}")
		If AliasArray[3] != none		
			AliasArray[3].GetActorReference().SetActorValue("Morality", Value)
		ElseIf AliasArray[3] == none
		EndIf
	ElseIf (Option == MoralityFollower5)
		FollowerMoralitySlider5 = Value
		SetSliderOptionValue(MoralityFollower5, FollowerMoralitySlider5, "{1}")
		If AliasArray[4] != none		
			AliasArray[4].GetActorReference().SetActorValue("Morality", Value)
		ElseIf AliasArray[4] == none
		EndIf
	ElseIf (Option == FollowerPosX1)
		Follower1Script.SetX(Value)
		SetSliderOptionValue(Option, Follower1Script.X, "{0}")
	ElseIf (Option == FollowerPosY1)
		Follower1Script.SetY(Value)
		SetSliderOptionValue(Option, Follower1Script.Y, "{0}")
	ElseIf (Option == FollowerPosX2)
		Follower2Script.SetX(Value)
		SetSliderOptionValue(Option, Follower2Script.X, "{0}")
	ElseIf (Option == FollowerPosY2)
		Follower2Script.SetY(Value)
		SetSliderOptionValue(Option, Follower2Script.Y, "{0}")
	ElseIf (Option == FollowerPosX3)
		Follower3Script.SetX(Value)
		SetSliderOptionValue(Option, Follower3Script.X, "{0}")
	ElseIf (Option == FollowerPosY3)
		Follower3Script.SetY(Value)
		SetSliderOptionValue(Option, Follower3Script.Y, "{0}")
	ElseIf (Option == FollowerPosX4)
		Follower4Script.SetX(Value)
		SetSliderOptionValue(Option, Follower4Script.X, "{0}")
	ElseIf (Option == FollowerPosY4)
		Follower4Script.SetY(Value)
		SetSliderOptionValue(Option, Follower4Script.Y, "{0}")
	ElseIf (Option == FollowerPosX5)
		Follower5Script.SetX(Value)
		SetSliderOptionValue(Option, Follower5Script.X, "{0}")
	ElseIf (Option == FollowerPosY5)
		Follower5Script.SetY(Value)
		SetSliderOptionValue(Option, Follower5Script.Y, "{0}")
	ElseIf (Option == FollowerAlpha1)
		Follower1Script.SetTransparency(Value)
		SetSliderOptionValue(Option, Follower1Script.Alpha, "{0}")
	ElseIf (Option == FollowerAlpha2)
		Follower2Script.SetTransparency(Value)
		SetSliderOptionValue(Option, Follower2Script.Alpha, "{0}")
	ElseIf (Option == FollowerAlpha3)
		Follower3Script.SetTransparency(Value)
		SetSliderOptionValue(Option, Follower3Script.Alpha, "{0}")
	ElseIf (Option == FollowerAlpha4)
		Follower4Script.SetTransparency(Value)
		SetSliderOptionValue(Option, Follower4Script.Alpha, "{0}")
	ElseIf (Option == FollowerAlpha5)
		Follower5Script.SetTransparency(Value)
		SetSliderOptionValue(Option, Follower5Script.Alpha, "{0}")
	ElseIf (Option == FollowerScale1)
		Follower1Script.Size = Value as Int
		SetSliderOptionValue(Option, Follower1Script.Size, "{0}%")
		ForcePageReset()
	ElseIf (Option == FollowerScale2)
		Follower2Script.Size = Value as Int
		SetSliderOptionValue(Option, Follower2Script.Size, "{0}%")
		ForcePageReset()
	ElseIf (Option == FollowerScale3)
		Follower3Script.Size = Value as Int
		SetSliderOptionValue(Option, Follower3Script.Size, "{0}%")
		ForcePageReset()
	ElseIf (Option == FollowerScale4)
		Follower4Script.Size = Value as Int
		SetSliderOptionValue(Option, Follower4Script.Size, "{0}%")
		ForcePageReset()
	ElseIf (Option == FollowerScale5)
		Follower5Script.Size = Value as Int
		SetSliderOptionValue(Option, Follower5Script.Size, "{0}%")
		ForcePageReset()
	ElseIf (Option == UpdateTimerInt)
		UpdateScript.UpdateTimer = Value
		SetSliderOptionValue(Option, UpdateScript.UpdateTimer, "{0} sec.")
		ForcePageReset()		
	EndIf

EndEvent

Event OnOptionMenuOpen(Int Option)

	If (Option == FollowerAnchorH1)
		SetMenuDialogStartIndex(HAnchorFollowerString1.Find(Follower1Script.HAnchor))
		SetMenuDialogDefaultIndex(0)
		SetMenuDialogOptions(HAnchorFollowerString1)
	ElseIf (Option == FollowerAnchorV1)
		SetMenuDialogStartIndex(VAnchorFollowerString1.Find(Follower1Script.VAnchor))
		SetMenuDialogDefaultIndex(0)
		SetMenuDialogOptions(VAnchorFollowerString1)
	ElseIf (Option == FollowerAnchorH2)
		SetMenuDialogStartIndex(HAnchorFollowerString2.Find(Follower2Script.HAnchor))
		SetMenuDialogDefaultIndex(0)
		SetMenuDialogOptions(HAnchorFollowerString2)
	ElseIf (Option == FollowerAnchorV2)
		SetMenuDialogStartIndex(VAnchorFollowerString2.Find(Follower2Script.VAnchor))
		SetMenuDialogDefaultIndex(0)
		SetMenuDialogOptions(VAnchorFollowerString2)
	ElseIf (Option == FollowerAnchorH3)
		SetMenuDialogStartIndex(HAnchorFollowerString3.Find(Follower3Script.HAnchor))
		SetMenuDialogDefaultIndex(0)
		SetMenuDialogOptions(HAnchorFollowerString3)
	ElseIf (Option == FollowerAnchorV3)
		SetMenuDialogStartIndex(VAnchorFollowerString3.Find(Follower3Script.VAnchor))
		SetMenuDialogDefaultIndex(0)
		SetMenuDialogOptions(VAnchorFollowerString3)
	ElseIf (Option == FollowerAnchorH4)
		SetMenuDialogStartIndex(HAnchorFollowerString4.Find(Follower4Script.HAnchor))
		SetMenuDialogDefaultIndex(0)
		SetMenuDialogOptions(HAnchorFollowerString4)
	ElseIf (Option == FollowerAnchorV4)
		SetMenuDialogStartIndex(VAnchorFollowerString4.Find(Follower4Script.VAnchor))
		SetMenuDialogDefaultIndex(0)
		SetMenuDialogOptions(VAnchorFollowerString4)
	ElseIf (Option == FollowerAnchorH5)
		SetMenuDialogStartIndex(HAnchorFollowerString5.Find(Follower5Script.HAnchor))
		SetMenuDialogDefaultIndex(0)
		SetMenuDialogOptions(HAnchorFollowerString5)
	ElseIf (Option == FollowerAnchorV5)
		SetMenuDialogStartIndex(VAnchorFollowerString5.Find(Follower5Script.VAnchor))
		SetMenuDialogDefaultIndex(0)
		SetMenuDialogOptions(VAnchorFollowerString5)
	ElseIf option == CStyle1
		SetMenuDialogOptions(CSList1)
		SetMenuDialogStartIndex(CStyleIndex1)
		SetMenuDialogDefaultIndex(0)
	ElseIf option == CStyle2
		SetMenuDialogOptions(CSList2)
		SetMenuDialogStartIndex(CStyleIndex2)
		SetMenuDialogDefaultIndex(0)
	ElseIf option == CStyle3
		SetMenuDialogOptions(CSList3)
		SetMenuDialogStartIndex(CStyleIndex3)
		SetMenuDialogDefaultIndex(0)
	ElseIf option == CStyle4
		SetMenuDialogOptions(CSList4)
		SetMenuDialogStartIndex(CStyleIndex4)
		SetMenuDialogDefaultIndex(0)
	ElseIf option == CStyle5
		SetMenuDialogOptions(CSList5)
		SetMenuDialogStartIndex(CStyleIndex5)
		SetMenuDialogDefaultIndex(0)		
	EndIf

EndEvent

Event OnOptionMenuAccept(Int Option, Int Index)

	If (Option == FollowerAnchorH1)
		Follower1Script.HAnchor = HAnchorFollowerString1[Index]
		SetMenuOptionValue(Option, HAnchorFollowerString1[HAnchorFollowerString1.Find(Follower1Script.HAnchor)])
		If Index == 0
			Follower1Script.X = 10
			ForcePageReset()
		ElseIf Index == 1
			Follower1Script.X = 1270
			ForcePageReset()
		ElseIf Index == 2
			Follower1Script.X = 630
			ForcePageReset()			
		EndIf	
	ElseIf (Option == FollowerAnchorV1)
		Follower1Script.VAnchor = VAnchorFollowerString1[Index]
		SetMenuOptionValue(Option, VAnchorFollowerString1[VAnchorFollowerString1.Find(Follower1Script.VAnchor)])
		If Index == 0
			Follower1Script.Y = 710
			ForcePageReset()
		ElseIf Index == 1
			Follower1Script.Y = 10
			ForcePageReset()
		ElseIf Index == 2
			Follower1Script.Y = 350
			ForcePageReset()			
		EndIf
	ElseIf (Option == FollowerAnchorH2)
		Follower2Script.HAnchor = HAnchorFollowerString2[Index]
		SetMenuOptionValue(Option, HAnchorFollowerString2[HAnchorFollowerString2.Find(Follower2Script.HAnchor)])
		If Index == 0
			Follower2Script.X = 10
			ForcePageReset()
		ElseIf Index == 1
			Follower2Script.X = 1270
			ForcePageReset()
		ElseIf Index == 2
			Follower2Script.X = 630
			ForcePageReset()			
		EndIf	
	ElseIf (Option == FollowerAnchorV2)
		Follower2Script.VAnchor = VAnchorFollowerString2[Index]
		SetMenuOptionValue(Option, VAnchorFollowerString2[VAnchorFollowerString2.Find(Follower2Script.VAnchor)])
		If Index == 0
			Follower2Script.Y = 710
			ForcePageReset()
		ElseIf Index == 1
			Follower2Script.Y = 10
			ForcePageReset()
		ElseIf Index == 2
			Follower2Script.Y = 350
			ForcePageReset()			
		EndIf	
	ElseIf (Option == FollowerAnchorH3)
		Follower3Script.HAnchor = HAnchorFollowerString3[Index]
		SetMenuOptionValue(Option, HAnchorFollowerString3[HAnchorFollowerString3.Find(Follower3Script.HAnchor)])
		If Index == 0
			Follower3Script.X = 10
			ForcePageReset()
		ElseIf Index == 1
			Follower3Script.X = 1270
			ForcePageReset()
		ElseIf Index == 2
			Follower3Script.X = 630
			ForcePageReset()			
		EndIf	
	ElseIf (Option == FollowerAnchorV3)
		Follower3Script.VAnchor = VAnchorFollowerString3[Index]
		SetMenuOptionValue(Option, VAnchorFollowerString3[VAnchorFollowerString3.Find(Follower3Script.VAnchor)])
		If Index == 0
			Follower3Script.Y = 710
			ForcePageReset()
		ElseIf Index == 1
			Follower3Script.Y = 10
			ForcePageReset()
		ElseIf Index == 2
			Follower3Script.Y = 350
			ForcePageReset()			
		EndIf
	ElseIf (Option == FollowerAnchorH4)
		Follower4Script.HAnchor = HAnchorFollowerString4[Index]
		SetMenuOptionValue(Option, HAnchorFollowerString4[HAnchorFollowerString4.Find(Follower4Script.HAnchor)])
		If Index == 0
			Follower4Script.X = 10
			ForcePageReset()
		ElseIf Index == 1
			Follower4Script.X = 1270
			ForcePageReset()
		ElseIf Index == 2
			Follower4Script.X = 630
			ForcePageReset()			
		EndIf	
	ElseIf (Option == FollowerAnchorH4)
		Follower4Script.VAnchor = VAnchorFollowerString4[Index]
		SetMenuOptionValue(Option, VAnchorFollowerString4[VAnchorFollowerString4.Find(Follower4Script.VAnchor)])
		If Index == 0
			Follower4Script.Y = 710
			ForcePageReset()
		ElseIf Index == 1
			Follower4Script.Y = 10
			ForcePageReset()
		ElseIf Index == 2
			Follower4Script.Y = 350
			ForcePageReset()			
		EndIf
	ElseIf (Option == FollowerAnchorH5)
		Follower5Script.HAnchor = HAnchorFollowerString5[Index]
		SetMenuOptionValue(Option, HAnchorFollowerString5[HAnchorFollowerString5.Find(Follower5Script.HAnchor)])
		If Index == 0
			Follower5Script.X = 10
			ForcePageReset()
		ElseIf Index == 1
			Follower5Script.X = 1270
			ForcePageReset()
		ElseIf Index == 2
			Follower5Script.X = 630
			ForcePageReset()			
		EndIf	
	ElseIf (Option == FollowerAnchorH5)
		Follower5Script.VAnchor = VAnchorFollowerString5[Index]
		SetMenuOptionValue(Option, VAnchorFollowerString5[VAnchorFollowerString5.Find(Follower5Script.VAnchor)])
		If Index == 0
			Follower5Script.Y = 710
			ForcePageReset()
		ElseIf Index == 1
			Follower5Script.Y = 10
			ForcePageReset()
		ElseIf Index == 2
			Follower5Script.Y = 350
			ForcePageReset()			
		EndIf
	ElseIf Option == CStyle1
		CStyleIndex1 = index
		SetMenuOptionValue(CStyle1, CSList1[CStyleIndex1])
		ActorBase Follower1 = FirstFollower.GetReference().GetBaseObject() as ActorBase		
		If CStyleIndex1 == 0				
			Follower1.SetCombatStyle(FM_CombatStyleFL.GetAt(0) as CombatStyle)				
		ElseIf CStyleIndex1 == 1
			Follower1.SetCombatStyle(FM_CombatStyleFL.GetAt(1) as CombatStyle)							
		ElseIf CStyleIndex1 == 2	
			Follower1.SetCombatStyle(FM_CombatStyleFL.GetAt(2) as CombatStyle)
		ElseIf CStyleIndex1 == 3	
			Follower1.SetCombatStyle(FM_CombatStyleFL.GetAt(3) as CombatStyle)
		ElseIf CStyleIndex1 == 4	
			Follower1.SetCombatStyle(FM_CombatStyleFL.GetAt(4) as CombatStyle)
		ElseIf CStyleIndex1 == 5	
			Follower1.SetCombatStyle(FM_CombatStyleFL.GetAt(5) as CombatStyle)
		ElseIf CStyleIndex1 == 6	
			Follower1.SetCombatStyle(FM_CombatStyleFL.GetAt(6) as CombatStyle)
		ElseIf CStyleIndex1 == 7	
			Follower1.SetCombatStyle(FM_CombatStyleFL.GetAt(7) as CombatStyle)
		ElseIf CStyleIndex1 == 8	
			Follower1.SetCombatStyle(FM_CombatStyleFL.GetAt(8) as CombatStyle)
		ElseIf CStyleIndex1 == 9	
			Follower1.SetCombatStyle(FM_CombatStyleFL.GetAt(9) as CombatStyle)
		ElseIf CStyleIndex1 == 10	
			Follower1.SetCombatStyle(FM_CombatStyleFL.GetAt(10) as CombatStyle)
		ElseIf CStyleIndex1 == 11	
			Follower1.SetCombatStyle(FM_CombatStyleFL.GetAt(11) as CombatStyle)			
		EndIf
	ElseIf Option == CStyle2
		CStyleIndex2 = index
		SetMenuOptionValue(CStyle2, CSList2[CStyleIndex2])
		ActorBase Follower2 = SecondFollower.GetReference().GetBaseObject() as ActorBase		
		If CStyleIndex2 == 0				
			Follower2.SetCombatStyle(FM_CombatStyleFL.GetAt(0) as CombatStyle)				
		ElseIf CStyleIndex2 == 1
			Follower2.SetCombatStyle(FM_CombatStyleFL.GetAt(1) as CombatStyle)							
		ElseIf CStyleIndex2 == 2	
			Follower2.SetCombatStyle(FM_CombatStyleFL.GetAt(2) as CombatStyle)
		ElseIf CStyleIndex2 == 3	
			Follower2.SetCombatStyle(FM_CombatStyleFL.GetAt(3) as CombatStyle)
		ElseIf CStyleIndex2 == 4	
			Follower2.SetCombatStyle(FM_CombatStyleFL.GetAt(4) as CombatStyle)
		ElseIf CStyleIndex2 == 5	
			Follower2.SetCombatStyle(FM_CombatStyleFL.GetAt(5) as CombatStyle)
		ElseIf CStyleIndex2 == 6	
			Follower2.SetCombatStyle(FM_CombatStyleFL.GetAt(6) as CombatStyle)
		ElseIf CStyleIndex2 == 7	
			Follower2.SetCombatStyle(FM_CombatStyleFL.GetAt(7) as CombatStyle)
		ElseIf CStyleIndex2 == 8	
			Follower2.SetCombatStyle(FM_CombatStyleFL.GetAt(8) as CombatStyle)
		ElseIf CStyleIndex2 == 9	
			Follower2.SetCombatStyle(FM_CombatStyleFL.GetAt(9) as CombatStyle)
		ElseIf CStyleIndex2 == 10	
			Follower2.SetCombatStyle(FM_CombatStyleFL.GetAt(10) as CombatStyle)
		ElseIf CStyleIndex2 == 11	
			Follower2.SetCombatStyle(FM_CombatStyleFL.GetAt(11) as CombatStyle)			
		EndIf
	ElseIf Option == CStyle3
		CStyleIndex3 = index
		SetMenuOptionValue(CStyle3, CSList3[CStyleIndex3])
		ActorBase Follower3 = ThirdFollower.GetReference().GetBaseObject() as ActorBase		
		If CStyleIndex3 == 0				
			Follower3.SetCombatStyle(FM_CombatStyleFL.GetAt(0) as CombatStyle)				
		ElseIf CStyleIndex3 == 1
			Follower3.SetCombatStyle(FM_CombatStyleFL.GetAt(1) as CombatStyle)							
		ElseIf CStyleIndex3 == 2	
			Follower3.SetCombatStyle(FM_CombatStyleFL.GetAt(2) as CombatStyle)
		ElseIf CStyleIndex3 == 3	
			Follower3.SetCombatStyle(FM_CombatStyleFL.GetAt(3) as CombatStyle)
		ElseIf CStyleIndex3 == 4	
			Follower3.SetCombatStyle(FM_CombatStyleFL.GetAt(4) as CombatStyle)
		ElseIf CStyleIndex3 == 5	
			Follower3.SetCombatStyle(FM_CombatStyleFL.GetAt(5) as CombatStyle)
		ElseIf CStyleIndex3 == 6	
			Follower3.SetCombatStyle(FM_CombatStyleFL.GetAt(6) as CombatStyle)
		ElseIf CStyleIndex3 == 7	
			Follower3.SetCombatStyle(FM_CombatStyleFL.GetAt(7) as CombatStyle)
		ElseIf CStyleIndex3 == 8	
			Follower3.SetCombatStyle(FM_CombatStyleFL.GetAt(8) as CombatStyle)
		ElseIf CStyleIndex3 == 9	
			Follower3.SetCombatStyle(FM_CombatStyleFL.GetAt(9) as CombatStyle)
		ElseIf CStyleIndex3 == 10	
			Follower3.SetCombatStyle(FM_CombatStyleFL.GetAt(10) as CombatStyle)
		ElseIf CStyleIndex3 == 11	
			Follower3.SetCombatStyle(FM_CombatStyleFL.GetAt(11) as CombatStyle)			
		EndIf
	ElseIf Option == CStyle4
		CStyleIndex4 = index
		SetMenuOptionValue(CStyle4, CSList4[CStyleIndex4])
		ActorBase Follower4 = FourthFollower.GetReference().GetBaseObject() as ActorBase		
		If CStyleIndex4 == 0				
			Follower4.SetCombatStyle(FM_CombatStyleFL.GetAt(0) as CombatStyle)				
		ElseIf CStyleIndex4 == 1
			Follower4.SetCombatStyle(FM_CombatStyleFL.GetAt(1) as CombatStyle)							
		ElseIf CStyleIndex4 == 2	
			Follower4.SetCombatStyle(FM_CombatStyleFL.GetAt(2) as CombatStyle)
		ElseIf CStyleIndex4 == 3	
			Follower4.SetCombatStyle(FM_CombatStyleFL.GetAt(3) as CombatStyle)
		ElseIf CStyleIndex4 == 4	
			Follower4.SetCombatStyle(FM_CombatStyleFL.GetAt(4) as CombatStyle)
		ElseIf CStyleIndex4 == 5	
			Follower4.SetCombatStyle(FM_CombatStyleFL.GetAt(5) as CombatStyle)
		ElseIf CStyleIndex4 == 6	
			Follower4.SetCombatStyle(FM_CombatStyleFL.GetAt(6) as CombatStyle)
		ElseIf CStyleIndex4 == 7	
			Follower4.SetCombatStyle(FM_CombatStyleFL.GetAt(7) as CombatStyle)
		ElseIf CStyleIndex4 == 8	
			Follower4.SetCombatStyle(FM_CombatStyleFL.GetAt(8) as CombatStyle)
		ElseIf CStyleIndex4 == 9	
			Follower4.SetCombatStyle(FM_CombatStyleFL.GetAt(9) as CombatStyle)
		ElseIf CStyleIndex4 == 10	
			Follower4.SetCombatStyle(FM_CombatStyleFL.GetAt(10) as CombatStyle)
		ElseIf CStyleIndex4 == 11	
			Follower4.SetCombatStyle(FM_CombatStyleFL.GetAt(11) as CombatStyle)			
		EndIf
	ElseIf Option == CStyle5
		CStyleIndex5 = index
		SetMenuOptionValue(CStyle5, CSList5[CStyleIndex5])
		ActorBase Follower5 = FifthFollower.GetReference().GetBaseObject() as ActorBase		
		If CStyleIndex5 == 0				
			Follower5.SetCombatStyle(FM_CombatStyleFL.GetAt(0) as CombatStyle)				
		ElseIf CStyleIndex5 == 1
			Follower5.SetCombatStyle(FM_CombatStyleFL.GetAt(1) as CombatStyle)							
		ElseIf CStyleIndex5 == 2	
			Follower5.SetCombatStyle(FM_CombatStyleFL.GetAt(2) as CombatStyle)
		ElseIf CStyleIndex5 == 3	
			Follower5.SetCombatStyle(FM_CombatStyleFL.GetAt(3) as CombatStyle)
		ElseIf CStyleIndex5 == 4	
			Follower5.SetCombatStyle(FM_CombatStyleFL.GetAt(4) as CombatStyle)
		ElseIf CStyleIndex5 == 5	
			Follower5.SetCombatStyle(FM_CombatStyleFL.GetAt(5) as CombatStyle)
		ElseIf CStyleIndex5 == 6	
			Follower5.SetCombatStyle(FM_CombatStyleFL.GetAt(6) as CombatStyle)
		ElseIf CStyleIndex5 == 7	
			Follower5.SetCombatStyle(FM_CombatStyleFL.GetAt(7) as CombatStyle)
		ElseIf CStyleIndex5 == 8	
			Follower5.SetCombatStyle(FM_CombatStyleFL.GetAt(8) as CombatStyle)
		ElseIf CStyleIndex5 == 9	
			Follower5.SetCombatStyle(FM_CombatStyleFL.GetAt(9) as CombatStyle)
		ElseIf CStyleIndex5 == 10	
			Follower5.SetCombatStyle(FM_CombatStyleFL.GetAt(10) as CombatStyle)
		ElseIf CStyleIndex5 == 11	
			Follower5.SetCombatStyle(FM_CombatStyleFL.GetAt(11) as CombatStyle)			
		EndIf		
	EndIf

EndEvent

Event OnOptionKeyMapChange(int a_option, int a_keyCode, string a_conflictControl, string a_conflictName)

	If a_option == KeyQuickTrade
		bool Continue = true
		If (a_conflictControl != "")
			string msg
			If (a_conflictName != "")
				msg = "This key is already mapped to:\n'" + a_conflictControl + "'\n(" + a_conflictName + ")\n\nAre you sure you want to continue?"
			Else
				msg = "This key is already mapped to:\n'" + a_conflictControl + "'\n\nAre you sure you want to continue?"
			EndIf
			Continue = ShowMessage(msg, true, "Yes", "No")
		EndIf
		If (Continue)
			KeyTrade = a_keyCode
			SetKeymapOptionValue(a_option, a_keyCode)
			RegisterForKey(KeyTrade)			
		EndIf
	ElseIf a_option == KeyQuickCommand
		bool Continue = true
		If (a_conflictControl != "")
			string msg
			If (a_conflictName != "")
				msg = "This key is already mapped to:\n'" + a_conflictControl + "'\n(" + a_conflictName + ")\n\nAre you sure you want to continue?"
			Else
				msg = "This key is already mapped to:\n'" + a_conflictControl + "'\n\nAre you sure you want to continue?"
			EndIf
			Continue = ShowMessage(msg, true, "Yes", "No")
		EndIf
		If (Continue)
			KeyCommand = a_keyCode
			SetKeymapOptionValue(a_option, a_keyCode)
			RegisterForKey(KeyCommand)			
		EndIf
	ElseIf a_option == KeyQuickSummon
		bool Continue = true
		If (a_conflictControl != "")
			string msg
			If (a_conflictName != "")
				msg = "This key is already mapped to:\n'" + a_conflictControl + "'\n(" + a_conflictName + ")\n\nAre you sure you want to continue?"
			Else
				msg = "This key is already mapped to:\n'" + a_conflictControl + "'\n\nAre you sure you want to continue?"
			EndIf
			Continue = ShowMessage(msg, true, "Yes", "No")
		EndIf
		If (Continue)
			KeySummon = a_keyCode
			SetKeymapOptionValue(a_option, a_keyCode)
			RegisterForKey(KeySummon)			
		EndIf
	ElseIf a_option == KeyQuickRelax
		bool Continue = true
		If (a_conflictControl != "")
			string msg
			If (a_conflictName != "")
				msg = "This key is already mapped to:\n'" + a_conflictControl + "'\n(" + a_conflictName + ")\n\nAre you sure you want to continue?"
			Else
				msg = "This key is already mapped to:\n'" + a_conflictControl + "'\n\nAre you sure you want to continue?"
			EndIf
			Continue = ShowMessage(msg, true, "Yes", "No")
		EndIf
		If (Continue)
			KeyRelax = a_keyCode
			SetKeymapOptionValue(a_option, a_keyCode)
			RegisterForKey(KeyRelax)			
		EndIf
	ElseIf a_option == KeyQuickAvoid
		bool Continue = true
		If (a_conflictControl != "")
			string msg
			If (a_conflictName != "")
				msg = "This key is already mapped to:\n'" + a_conflictControl + "'\n(" + a_conflictName + ")\n\nAre you sure you want to continue?"
			Else
				msg = "This key is already mapped to:\n'" + a_conflictControl + "'\n\nAre you sure you want to continue?"
			EndIf
			Continue = ShowMessage(msg, true, "Yes", "No")
		EndIf
		If (Continue)
			KeyAvoid = a_keyCode
			SetKeymapOptionValue(a_option, a_keyCode)
			RegisterForKey(KeyAvoid)			
		EndIf
	ElseIf a_option == KeyQuickLookBack
		bool Continue = true
		If (a_conflictControl != "")
			string msg
			If (a_conflictName != "")
				msg = "This key is already mapped to:\n'" + a_conflictControl + "'\n(" + a_conflictName + ")\n\nAre you sure you want to continue?"
			Else
				msg = "This key is already mapped to:\n'" + a_conflictControl + "'\n\nAre you sure you want to continue?"
			EndIf
			Continue = ShowMessage(msg, true, "Yes", "No")
		EndIf
		If (Continue)
			KeyLookBack = a_keyCode
			SetKeymapOptionValue(a_option, a_keyCode)
			RegisterForKey(KeyLookBack)			
		EndIf
	ElseIf a_option == KeyQuickDrawWeapon
		bool Continue = true
		If (a_conflictControl != "")
			string msg
			If (a_conflictName != "")
				msg = "This key is already mapped to:\n'" + a_conflictControl + "'\n(" + a_conflictName + ")\n\nAre you sure you want to continue?"
			Else
				msg = "This key is already mapped to:\n'" + a_conflictControl + "'\n\nAre you sure you want to continue?"
			EndIf
			Continue = ShowMessage(msg, true, "Yes", "No")
		EndIf
		If (Continue)
			KeyDrawWeapon = a_keyCode
			SetKeymapOptionValue(a_option, a_keyCode)
			RegisterForKey(KeyDrawWeapon)			
		EndIf
	EndIf

EndEvent

Event OnKeyDown(Int aiKeyCode)

	If aiKeyCode == KeyTrade && (!Utility.IsInMenuMode() && !UI.IsTextInputEnabled())
		FollowerTradeFirst()
	EndIf
	If aiKeyCode == KeySummon && (!Utility.IsInMenuMode() && !UI.IsTextInputEnabled())
		SummonFollower()
	EndIf
	If aiKeyCode == KeyRelax && (!Utility.IsInMenuMode() && !UI.IsTextInputEnabled())
		RelaxFollower()
	EndIf
	If aiKeyCode == KeyAvoid && (!Utility.IsInMenuMode() && !UI.IsTextInputEnabled())
		NoCombatFollower()
	EndIf
	If aiKeyCode == KeyLookBack && (!Utility.IsInMenuMode() && !UI.IsTextInputEnabled())
		If PressedKeyOnceLockBack == false
			LookBackFollower()
		ElseIf PressedKeyOnceLockBack == true
			LookBackFollowerReturn()
		EndIf	
	EndIf
	If aiKeyCode == KeyDrawWeapon && (!Utility.IsInMenuMode() && !UI.IsTextInputEnabled())
		DrawWeaponFollower()
	EndIf

EndEvent

Event OnKeyUp(Int aiKeyCode, Float HoldTime)

	If aiKeyCode == KeyTrade && UI.IsMenuOpen("ContainerMenu")
		If HoldTime >= 1 && HoldTime < 2
			FollowerTradeSecond()
		ElseIf HoldTime >= 2 && HoldTime < 3
			FollowerTradeThird()
		ElseIf HoldTime >= 3 && HoldTime < 4
			FollowerTradeFourth()
		ElseIf HoldTime >= 4 && HoldTime < 5
			FollowerTradeFifth()			
		ElseIf HoldTime < 1 && HoldTime != 1 		
			FollowerTradeFirst()
		EndIf	
	EndIf
	If aiKeyCode == KeyCommand && (!Utility.IsInMenuMode() && !UI.IsTextInputEnabled())
		If HoldTime >= 1
			FollowerCommand()
		ElseIf HoldTime < 1 && HoldTime != 1 
			FollowerWait()
		EndIf
	EndIf
	If aiKeyCode == KeyLookBack && (!Utility.IsInMenuMode() && !UI.IsTextInputEnabled())
		If HoldTime >= 1
			LookBackFollowerReturn()
		EndIf	
	EndIf

EndEvent

Function RestoreActorValues()

	If !BumpTimeToggle
		Game.SetGameSettingFloat("fBumpReactionIdealMoveDist", 125.000000)
		Game.SetGameSettingFloat("fBumpReactionMinMoveDist", 75.000000)
		Game.SetGameSettingFloat("fBumpReactionSmallDelayTime", 1.000000)
		Game.SetGameSettingFloat("fBumpReactionSmallWaitTimer", 3.000000)
	ElseIf BumpTimeToggle
		Game.SetGameSettingFloat("fBumpReactionIdealMoveDist", 250.000000)
		Game.SetGameSettingFloat("fBumpReactionMinMoveDist", 150.000000)
		Game.SetGameSettingFloat("fBumpReactionSmallDelayTime", 0.500000)
		Game.SetGameSettingFloat("fBumpReactionSmallWaitTimer", 0.500000)		
	EndIf	
	If !WeapDrawToggle
		Game.SetGameSettingFloat("fAIDistanceTeammateDrawWeapon", 2000.000000)
	ElseIf WeapDrawToggle
		Game.SetGameSettingFloat("fAIDistanceTeammateDrawWeapon", 0.000000)		
	EndIf	
	If AliasArray[0].GetActorReference() != none
		AliasArray[0].GetActorReference().SetActorValue("CarryWeight", CarryWeightPointsFollowerSlider1)
		AliasArray[0].GetActorReference().SetActorValue("SpeedMult", SpeedPointsFollowerSlider1)
		AliasArray[0].GetActorReference().SetActorValue("Aggression", FollowerAggressionSlider1)
		AliasArray[0].GetActorReference().SetActorValue("Confidence", FollowerConfidenceSlider1)
		AliasArray[0].GetActorReference().SetActorValue("Assistance", FollowerAssistanceSlider1)
		AliasArray[0].GetActorReference().SetActorValue("Morality", FollowerMoralitySlider1)	
	ElseIf AliasArray[0].GetActorReference() == none
	EndIf
	If AliasArray[1].GetActorReference() != none
		AliasArray[1].GetActorReference().SetActorValue("CarryWeight", CarryWeightPointsFollowerSlider2)
		AliasArray[1].GetActorReference().SetActorValue("SpeedMult", SpeedPointsFollowerSlider2)
		AliasArray[1].GetActorReference().SetActorValue("Aggression", FollowerAggressionSlider2)
		AliasArray[1].GetActorReference().SetActorValue("Confidence", FollowerConfidenceSlider2)
		AliasArray[1].GetActorReference().SetActorValue("Assistance", FollowerAssistanceSlider2)
		AliasArray[1].GetActorReference().SetActorValue("Morality", FollowerMoralitySlider2)	
	ElseIf AliasArray[1].GetActorReference() == none
	EndIf
	If AliasArray[2].GetActorReference() != none
		AliasArray[2].GetActorReference().SetActorValue("CarryWeight", CarryWeightPointsFollowerSlider3)
		AliasArray[2].GetActorReference().SetActorValue("SpeedMult", SpeedPointsFollowerSlider3)
		AliasArray[2].GetActorReference().SetActorValue("Aggression", FollowerAggressionSlider3)
		AliasArray[2].GetActorReference().SetActorValue("Confidence", FollowerConfidenceSlider3)
		AliasArray[2].GetActorReference().SetActorValue("Assistance", FollowerAssistanceSlider3)
		AliasArray[2].GetActorReference().SetActorValue("Morality", FollowerMoralitySlider3)	
	ElseIf AliasArray[2].GetActorReference() == none
	EndIf
	If AliasArray[3].GetActorReference() != none
		AliasArray[3].GetActorReference().SetActorValue("CarryWeight", CarryWeightPointsFollowerSlider4)
		AliasArray[3].GetActorReference().SetActorValue("SpeedMult", SpeedPointsFollowerSlider4)
		AliasArray[3].GetActorReference().SetActorValue("Aggression", FollowerAggressionSlider4)
		AliasArray[3].GetActorReference().SetActorValue("Confidence", FollowerConfidenceSlider4)
		AliasArray[3].GetActorReference().SetActorValue("Assistance", FollowerAssistanceSlider4)
		AliasArray[3].GetActorReference().SetActorValue("Morality", FollowerMoralitySlider4)	
	ElseIf AliasArray[3].GetActorReference() == none
	EndIf
	If AliasArray[4].GetActorReference() != none
		AliasArray[4].GetActorReference().SetActorValue("CarryWeight", CarryWeightPointsFollowerSlider5)
		AliasArray[4].GetActorReference().SetActorValue("SpeedMult", SpeedPointsFollowerSlider5)
		AliasArray[4].GetActorReference().SetActorValue("Aggression", FollowerAggressionSlider5)
		AliasArray[4].GetActorReference().SetActorValue("Confidence", FollowerConfidenceSlider5)
		AliasArray[4].GetActorReference().SetActorValue("Assistance", FollowerAssistanceSlider5)
		AliasArray[4].GetActorReference().SetActorValue("Morality", FollowerMoralitySlider5)	
	ElseIf AliasArray[4].GetActorReference() == none
	EndIf
	
	ActorBase Follower1 = FirstFollower.GetReference().GetBaseObject() as ActorBase
	ActorBase Follower2 = SecondFollower.GetReference().GetBaseObject() as ActorBase
	ActorBase Follower3 = ThirdFollower.GetReference().GetBaseObject() as ActorBase
	ActorBase Follower4 = FourthFollower.GetReference().GetBaseObject() as ActorBase
	ActorBase Follower5 = FifthFollower.GetReference().GetBaseObject() as ActorBase	
	If CStyleIndex1 == 0				
		Follower1.SetCombatStyle(FM_CombatStyleFL.GetAt(0) as CombatStyle)				
	ElseIf CStyleIndex1 == 1
		Follower1.SetCombatStyle(FM_CombatStyleFL.GetAt(1) as CombatStyle)							
	ElseIf CStyleIndex1 == 2	
		Follower1.SetCombatStyle(FM_CombatStyleFL.GetAt(2) as CombatStyle)
	ElseIf CStyleIndex1 == 3	
		Follower1.SetCombatStyle(FM_CombatStyleFL.GetAt(3) as CombatStyle)
	ElseIf CStyleIndex1 == 4	
		Follower1.SetCombatStyle(FM_CombatStyleFL.GetAt(4) as CombatStyle)
	ElseIf CStyleIndex1 == 5	
		Follower1.SetCombatStyle(FM_CombatStyleFL.GetAt(5) as CombatStyle)
	ElseIf CStyleIndex1 == 6	
		Follower1.SetCombatStyle(FM_CombatStyleFL.GetAt(6) as CombatStyle)
	ElseIf CStyleIndex1 == 7	
		Follower1.SetCombatStyle(FM_CombatStyleFL.GetAt(7) as CombatStyle)
	ElseIf CStyleIndex1 == 8	
		Follower1.SetCombatStyle(FM_CombatStyleFL.GetAt(8) as CombatStyle)
	ElseIf CStyleIndex1 == 9	
		Follower1.SetCombatStyle(FM_CombatStyleFL.GetAt(9) as CombatStyle)
	ElseIf CStyleIndex1 == 10	
		Follower1.SetCombatStyle(FM_CombatStyleFL.GetAt(10) as CombatStyle)
	ElseIf CStyleIndex1 == 11	
		Follower1.SetCombatStyle(FM_CombatStyleFL.GetAt(11) as CombatStyle)	
	ElseIf CStyleIndex2 == 0				
		Follower2.SetCombatStyle(FM_CombatStyleFL.GetAt(0) as CombatStyle)				
	ElseIf CStyleIndex2 == 1
		Follower2.SetCombatStyle(FM_CombatStyleFL.GetAt(1) as CombatStyle)							
	ElseIf CStyleIndex2 == 2	
		Follower2.SetCombatStyle(FM_CombatStyleFL.GetAt(2) as CombatStyle)
	ElseIf CStyleIndex2 == 3	
		Follower2.SetCombatStyle(FM_CombatStyleFL.GetAt(3) as CombatStyle)
	ElseIf CStyleIndex2 == 4	
		Follower2.SetCombatStyle(FM_CombatStyleFL.GetAt(4) as CombatStyle)
	ElseIf CStyleIndex2 == 5	
		Follower2.SetCombatStyle(FM_CombatStyleFL.GetAt(5) as CombatStyle)
	ElseIf CStyleIndex2 == 6	
		Follower2.SetCombatStyle(FM_CombatStyleFL.GetAt(6) as CombatStyle)
	ElseIf CStyleIndex2 == 7	
		Follower2.SetCombatStyle(FM_CombatStyleFL.GetAt(7) as CombatStyle)
	ElseIf CStyleIndex2 == 8	
		Follower2.SetCombatStyle(FM_CombatStyleFL.GetAt(8) as CombatStyle)
	ElseIf CStyleIndex2 == 9	
		Follower2.SetCombatStyle(FM_CombatStyleFL.GetAt(9) as CombatStyle)
	ElseIf CStyleIndex2 == 10	
		Follower2.SetCombatStyle(FM_CombatStyleFL.GetAt(10) as CombatStyle)
	ElseIf CStyleIndex2 == 11	
		Follower2.SetCombatStyle(FM_CombatStyleFL.GetAt(11) as CombatStyle)
	ElseIf CStyleIndex3 == 0				
		Follower3.SetCombatStyle(FM_CombatStyleFL.GetAt(0) as CombatStyle)				
	ElseIf CStyleIndex3 == 1
		Follower3.SetCombatStyle(FM_CombatStyleFL.GetAt(1) as CombatStyle)							
	ElseIf CStyleIndex3 == 2	
		Follower3.SetCombatStyle(FM_CombatStyleFL.GetAt(2) as CombatStyle)
	ElseIf CStyleIndex3 == 3	
		Follower3.SetCombatStyle(FM_CombatStyleFL.GetAt(3) as CombatStyle)
	ElseIf CStyleIndex3 == 4	
		Follower3.SetCombatStyle(FM_CombatStyleFL.GetAt(4) as CombatStyle)
	ElseIf CStyleIndex3 == 5	
		Follower3.SetCombatStyle(FM_CombatStyleFL.GetAt(5) as CombatStyle)
	ElseIf CStyleIndex3 == 6	
		Follower3.SetCombatStyle(FM_CombatStyleFL.GetAt(6) as CombatStyle)
	ElseIf CStyleIndex3 == 7	
		Follower3.SetCombatStyle(FM_CombatStyleFL.GetAt(7) as CombatStyle)
	ElseIf CStyleIndex3 == 8	
		Follower3.SetCombatStyle(FM_CombatStyleFL.GetAt(8) as CombatStyle)
	ElseIf CStyleIndex3 == 9	
		Follower3.SetCombatStyle(FM_CombatStyleFL.GetAt(9) as CombatStyle)
	ElseIf CStyleIndex3 == 10	
		Follower3.SetCombatStyle(FM_CombatStyleFL.GetAt(10) as CombatStyle)
	ElseIf CStyleIndex3 == 11	
		Follower3.SetCombatStyle(FM_CombatStyleFL.GetAt(11) as CombatStyle)	
	ElseIf CStyleIndex4 == 0				
		Follower4.SetCombatStyle(FM_CombatStyleFL.GetAt(0) as CombatStyle)				
	ElseIf CStyleIndex4 == 1
		Follower4.SetCombatStyle(FM_CombatStyleFL.GetAt(1) as CombatStyle)							
	ElseIf CStyleIndex4 == 2	
		Follower4.SetCombatStyle(FM_CombatStyleFL.GetAt(2) as CombatStyle)
	ElseIf CStyleIndex4 == 3	
		Follower4.SetCombatStyle(FM_CombatStyleFL.GetAt(3) as CombatStyle)
	ElseIf CStyleIndex4 == 4	
		Follower4.SetCombatStyle(FM_CombatStyleFL.GetAt(4) as CombatStyle)
	ElseIf CStyleIndex4 == 5	
		Follower4.SetCombatStyle(FM_CombatStyleFL.GetAt(5) as CombatStyle)
	ElseIf CStyleIndex4 == 6	
		Follower4.SetCombatStyle(FM_CombatStyleFL.GetAt(6) as CombatStyle)
	ElseIf CStyleIndex4 == 7	
		Follower4.SetCombatStyle(FM_CombatStyleFL.GetAt(7) as CombatStyle)
	ElseIf CStyleIndex4 == 8	
		Follower4.SetCombatStyle(FM_CombatStyleFL.GetAt(8) as CombatStyle)
	ElseIf CStyleIndex4 == 9	
		Follower4.SetCombatStyle(FM_CombatStyleFL.GetAt(9) as CombatStyle)
	ElseIf CStyleIndex4 == 10	
		Follower4.SetCombatStyle(FM_CombatStyleFL.GetAt(10) as CombatStyle)
	ElseIf CStyleIndex4 == 11	
		Follower4.SetCombatStyle(FM_CombatStyleFL.GetAt(11) as CombatStyle)
	ElseIf CStyleIndex5 == 0				
		Follower5.SetCombatStyle(FM_CombatStyleFL.GetAt(0) as CombatStyle)				
	ElseIf CStyleIndex5 == 1
		Follower5.SetCombatStyle(FM_CombatStyleFL.GetAt(1) as CombatStyle)							
	ElseIf CStyleIndex5 == 2	
		Follower5.SetCombatStyle(FM_CombatStyleFL.GetAt(2) as CombatStyle)
	ElseIf CStyleIndex5 == 3	
		Follower5.SetCombatStyle(FM_CombatStyleFL.GetAt(3) as CombatStyle)
	ElseIf CStyleIndex5 == 4	
		Follower5.SetCombatStyle(FM_CombatStyleFL.GetAt(4) as CombatStyle)
	ElseIf CStyleIndex5 == 5	
		Follower5.SetCombatStyle(FM_CombatStyleFL.GetAt(5) as CombatStyle)
	ElseIf CStyleIndex5 == 6	
		Follower5.SetCombatStyle(FM_CombatStyleFL.GetAt(6) as CombatStyle)
	ElseIf CStyleIndex5 == 7	
		Follower5.SetCombatStyle(FM_CombatStyleFL.GetAt(7) as CombatStyle)
	ElseIf CStyleIndex5 == 8	
		Follower5.SetCombatStyle(FM_CombatStyleFL.GetAt(8) as CombatStyle)
	ElseIf CStyleIndex5 == 9	
		Follower5.SetCombatStyle(FM_CombatStyleFL.GetAt(9) as CombatStyle)
	ElseIf CStyleIndex5 == 10	
		Follower5.SetCombatStyle(FM_CombatStyleFL.GetAt(10) as CombatStyle)
	ElseIf CStyleIndex5 == 11	
		Follower5.SetCombatStyle(FM_CombatStyleFL.GetAt(11) as CombatStyle)			
	EndIf	

	InitKeys()	

EndFunction

Function InitKeys(Int aiDXScanCode = 0)

	RegisterForKey(KeyTrade)
	RegisterForKey(KeyCommand)
 	RegisterForKey(KeySummon)
	RegisterForKey(KeyRelax)
 	RegisterForKey(KeyAvoid)
	RegisterForKey(KeyLookBack)
	RegisterForKey(KeyDrawWeapon)
		
EndFunction

Function FollowerTradeFirst(Int aiIndex = 48)
	While (aiIndex > 0)
		aiIndex -= 1
		If AliasArrayCommands[aiIndex].GetActorReference().IsInFaction(CurrentFollowerFaction) && AliasArrayCommands[aiIndex].GetActorReference().GetDistance(PlayerREF) <= 500
			AliasArrayCommands[aiIndex].GetActorReference().OpenInventory()
		EndIf
	EndWhile
EndFunction

Function FollowerTradeSecond()
	Int AbortKey = Input.GetMappedKey("Tween Menu")
	Input.TapKey(AbortKey)
	If SecondFollower.GetActorReference().IsInFaction(CurrentFollowerFaction) && SecondFollower.GetActorReference().GetDistance(PlayerREF) <= 500
		SecondFollower.GetActorReference().OpenInventory()
	EndIf
EndFunction

Function FollowerTradeThird()
	Int AbortKey = Input.GetMappedKey("Tween Menu")
	Input.TapKey(AbortKey)
	If ThirdFollower.GetActorReference().IsInFaction(CurrentFollowerFaction) && ThirdFollower.GetActorReference().GetDistance(PlayerREF) <= 500
		ThirdFollower.GetActorReference().OpenInventory()
	EndIf
EndFunction

Function FollowerTradeFourth()
	Int AbortKey = Input.GetMappedKey("Tween Menu")
	Input.TapKey(AbortKey)
	If FourthFollower.GetActorReference().IsInFaction(CurrentFollowerFaction) && FourthFollower.GetActorReference().GetDistance(PlayerREF) <= 500
		FourthFollower.GetActorReference().OpenInventory()
	EndIf
EndFunction

Function FollowerTradeFifth()
	Int AbortKey = Input.GetMappedKey("Tween Menu")
	Input.TapKey(AbortKey)
	If FifthFollower.GetActorReference().IsInFaction(CurrentFollowerFaction) && FifthFollower.GetActorReference().GetDistance(PlayerREF) <= 500
		FifthFollower.GetActorReference().OpenInventory()
	EndIf
EndFunction

Function FollowerWait(Int aiIndex = 48)
	While (aiIndex > 0)
		aiIndex -= 1
		If AliasArrayCommands[aiIndex].GetActorReference().GetActorValue("WaitingForPlayer") == 0 && AliasArrayCommands[aiIndex].GetActorReference().GetDistance(PlayerREF) <= 2000
			Debug.Notification("Follower waits for you") 
			AliasArrayCommands[aiIndex].GetActorReference().RegisterForUpdateGameTime(72)
			AliasArrayCommands[aiIndex].GetActorReference().SetActorValue("WaitingForPlayer", 1)
			AliasArrayCommands[aiIndex].GetActorReference().EvaluatePackage()
		ElseIf AliasArrayCommands[aiIndex].GetActorReference().GetActorValue("WaitingForPlayer") == 1 && AliasArrayCommands[aiIndex].GetActorReference().GetDistance(PlayerREF) <= 2000
			Debug.Notification("Follower follows you")			
			AliasArrayCommands[aiIndex].GetActorReference().UnRegisterForUpdate()
			AliasArrayCommands[aiIndex].GetActorReference().SetActorValue("WaitingForPlayer", 0)
			AliasArrayCommands[aiIndex].GetActorReference().EvaluatePackage()
		EndIf
	EndWhile
EndFunction

Function FollowerCommand(Int aiIndex = 48)
	While (aiIndex > 0)
		aiIndex -= 1
		If AliasArrayCommands[aiIndex].GetActorReference().IsInFaction(CurrentFollowerFaction) && AliasArrayCommands[aiIndex].GetActorReference().GetDistance(PlayerREF) <= 2000
			AliasArrayCommands[aiIndex].GetActorReference().SetDoingFavor()
		EndIf
	EndWhile
EndFunction

Function SummonFollower(Int aiIndex = 48)
	While (aiIndex > 0)
		aiIndex -= 1
		If AliasArrayCommands[aiIndex].GetActorReference().IsInFaction(CurrentFollowerFaction)
			AliasArrayCommands[aiIndex].GetActorReference().SetAlpha(0, false)
			AliasArrayCommands[aiIndex].GetActorReference().MoveTo(PlayerREF)
			MGTeleportInEffect.Play(AliasArrayCommands[aiIndex].GetActorReference(), 2)
			AliasArrayCommands[aiIndex].GetActorReference().SetAlpha(1, true)
		EndIf
	EndWhile
EndFunction

Function RelaxFollower(Int aiIndex = 48)
	While (aiIndex > 0)
		aiIndex -= 1
		If AliasArrayCommands[aiIndex].GetActorReference().IsInFaction(FM_RelaxFaction) == 0 && AliasArrayCommands[aiIndex].GetActorReference().GetDistance(PlayerREF) <= 2000 && AliasArrayCommands[aiIndex].GetActorReference().GetAv("WaitingForPlayer") == 0
			Debug.Notification("Follower relaxes")
			AliasArrayCommands[aiIndex].GetActorReference().AddToFaction(FM_RelaxFaction)
			AliasArrayCommands[aiIndex].GetActorReference().EvaluatePackage()
		ElseIf AliasArrayCommands[aiIndex].GetActorReference().IsInFaction(FM_RelaxFaction) == 1 && AliasArrayCommands[aiIndex].GetActorReference().GetDistance(PlayerREF) <= 2000 && AliasArrayCommands[aiIndex].GetActorReference().GetAv("WaitingForPlayer") == 0
			Debug.Notification("Follower is relaxed")
			AliasArrayCommands[aiIndex].GetActorReference().RemoveFromFaction(FM_RelaxFaction)
			AliasArrayCommands[aiIndex].GetActorReference().EvaluatePackage()
		EndIf
	EndWhile
EndFunction

Function NoCombatFollower(Int aiIndex = 48)
	While (aiIndex > 0)
		aiIndex -= 1
		If AliasArrayCommands[aiIndex].GetActorReference().IsInFaction(FM_AvoidCombatFaction) == 0 && AliasArrayCommands[aiIndex].GetActorReference().GetDistance(PlayerREF) <= 2000 && AliasArrayCommands[aiIndex].GetActorReference().GetAv("WaitingForPlayer") == 0
			Debug.Notification("Follower avoids combat")
			AliasArrayCommands[aiIndex].GetActorReference().AddToFaction(FM_AvoidCombatFaction)
			AliasArrayCommands[aiIndex].GetActorReference().EvaluatePackage()
		ElseIf AliasArrayCommands[aiIndex].GetActorReference().IsInFaction(FM_AvoidCombatFaction) == 1 && AliasArrayCommands[aiIndex].GetActorReference().GetDistance(PlayerREF) <= 2000 && AliasArrayCommands[aiIndex].GetActorReference().GetAv("WaitingForPlayer") == 0
			Debug.Notification("Follower will enter combat")
			AliasArrayCommands[aiIndex].GetActorReference().RemoveFromFaction(FM_AvoidCombatFaction)
			AliasArrayCommands[aiIndex].GetActorReference().EvaluatePackage()
		EndIf
	EndWhile
EndFunction

Function LookBackFollower(Int aiIndex = 48)
	While (aiIndex > 0)
		aiIndex -= 1
		If AliasArrayCommands[aiIndex].GetActorReference().IsInFaction(CurrentFollowerFaction)
			Game.SetCameraTarget(CameraFollower.GetActorReference())
			Game.ForceThirdPerson()
		EndIf
	EndWhile
	PressedKeyOnceLockBack = true
EndFunction

Function LookBackFollowerReturn(Int aiIndex = 48)
	Game.SetCameraTarget(PlayerREF)
	Game.ForceFirstPerson()
	PressedKeyOnceLockBack = false
EndFunction

Function DrawWeaponFollower(Int aiIndex = 48)
	While (aiIndex > 0)
		aiIndex -= 1		
		If AliasArrayCommands[aiIndex].GetActorReference().IsInFaction(CurrentFollowerFaction)
			If !AliasArrayCommands[aiIndex].GetActorReference().IsWeaponDrawn()
				Game.SetGameSettingFloat("fAIDistanceTeammateDrawWeapon", 2000.0)			
				AliasArrayCommands[aiIndex].GetActorReference().DrawWeapon()
				PlayerREF.DrawWeapon()
			ElseIf AliasArrayCommands[aiIndex].GetActorReference().IsWeaponDrawn()
				AliasArrayCommands[aiIndex].GetActorReference().SheatheWeapon()
				PlayerREF.SheatheWeapon()
				Game.SetGameSettingFloat("fAIDistanceTeammateDrawWeapon", 0.0)		
			EndIf
		EndIf
	EndWhile
EndFunction

Function LoadUserPreset()

	FISSInterface fiss = FISSFactory.getFISS()
	fiss.beginLoad("FMUserSettings.xml")
	
	FollowerWidget1 = fiss.loadInt("FISS_FollowerWidget1")
	Follower1Script.Visible = fiss.loadBool("FISS_FollowerWidgetScript1")
	FollowerPosX1 = fiss.loadInt("FISS_FollowerPosX1")
	Follower1Script.X = fiss.loadFloat("FISS_FollowerPosXScript1")
	FollowerPosY1 = fiss.loadInt("FISS_FollowerPosY1")
	Follower1Script.Y = fiss.loadFloat("FISS_FollowerPosYScript1")
	FollowerAlpha1 = fiss.loadInt("FISS_FollowerAlpha1")
	Follower1Script.Alpha = fiss.loadFloat("FISS_FollowerAlphaScript1")
	FollowerScale1 = fiss.loadInt("FISS_FollowerScale1")
	Follower1Script.Size = fiss.loadInt("FISS_FollowerScaleScript1")
	FollowerWidget2 = fiss.loadInt("FISS_FollowerWidget2")
	Follower2Script.Visible = fiss.loadBool("FISS_FollowerWidgetScript2")
	FollowerPosX2 = fiss.loadInt("FISS_FollowerPosX2")
	Follower2Script.X = fiss.loadFloat("FISS_FollowerPosXScript2")
	FollowerPosY2 = fiss.loadInt("FISS_FollowerPosY2")
	Follower2Script.Y = fiss.loadFloat("FISS_FollowerPosYScript2")
	FollowerAlpha2 = fiss.loadInt("FISS_FollowerAlpha2")
	Follower2Script.Alpha = fiss.loadFloat("FISS_FollowerAlphaScript2")
	FollowerScale2 = fiss.loadInt("FISS_FollowerScale2")
	Follower2Script.Size = fiss.loadInt("FISS_FollowerScaleScript2")
	FollowerWidget3 = fiss.loadInt("FISS_FollowerWidget3")
	Follower3Script.Visible = fiss.loadBool("FISS_FollowerWidgetScript3")
	FollowerPosX3 = fiss.loadInt("FISS_FollowerPosX3")
	Follower3Script.X = fiss.loadFloat("FISS_FollowerPosXScript3")
	FollowerPosY3 = fiss.loadInt("FISS_FollowerPosY3")
	Follower3Script.Y = fiss.loadFloat("FISS_FollowerPosYScript3")
	FollowerAlpha3 = fiss.loadInt("FISS_FollowerAlpha3")
	Follower3Script.Alpha = fiss.loadFloat("FISS_FollowerAlphaScript3")
	FollowerScale3 = fiss.loadInt("FISS_FollowerScale3")
	Follower3Script.Size = fiss.loadInt("FISS_FollowerScaleScript3")
	FollowerWidget4 = fiss.loadInt("FISS_FollowerWidget4")
	Follower4Script.Visible = fiss.loadBool("FISS_FollowerWidgetScript4")
	FollowerPosX4 = fiss.loadInt("FISS_FollowerPosX4")
	Follower4Script.X = fiss.loadFloat("FISS_FollowerPosXScript4")
	FollowerPosY4 = fiss.loadInt("FISS_FollowerPosY4")
	Follower4Script.Y = fiss.loadFloat("FISS_FollowerPosYScript4")
	FollowerAlpha4 = fiss.loadInt("FISS_FollowerAlpha4")
	Follower4Script.Alpha = fiss.loadFloat("FISS_FollowerAlphaScript4")
	FollowerScale4 = fiss.loadInt("FISS_FollowerScale4")
	Follower4Script.Size = fiss.loadInt("FISS_FollowerScaleScript4")
	FollowerWidget5 = fiss.loadInt("FISS_FollowerWidget5")
	Follower5Script.Visible = fiss.loadBool("FISS_FollowerWidgetScript5")
	FollowerPosX5 = fiss.loadInt("FISS_FollowerPosX5")
	Follower5Script.X = fiss.loadFloat("FISS_FollowerPosXScript5")
	FollowerPosY5 = fiss.loadInt("FISS_FollowerPosY5")
	Follower5Script.Y = fiss.loadFloat("FISS_FollowerPosYScript5")
	FollowerAlpha5 = fiss.loadInt("FISS_FollowerAlpha5")
	Follower5Script.Alpha = fiss.loadFloat("FISS_FollowerAlphaScript5")
	FollowerScale5 = fiss.loadInt("FISS_FollowerScale5")
	Follower5Script.Size = fiss.loadInt("FISS_FollowerScaleScript5")		

EndFunction

Function SaveUserPreset()

	FISSInterface fiss = FISSFactory.getFISS()
	fiss.beginSave("FMUserSettings.xml", " Follower Mod")
	
	fiss.saveInt("FISS_FollowerWidget1", FollowerWidget1)
	fiss.saveBool("FISS_FollowerWidgetScript1", Follower1Script.Visible)
	fiss.saveInt("FISS_FollowerPosX1", FollowerPosX1)
	fiss.saveFloat("FISS_FollowerPosXScript1", Follower1Script.X)
	fiss.saveInt("FISS_FollowerPosY1", FollowerPosY1)
	fiss.saveFloat("FISS_FollowerPosYScript1", Follower1Script.Y)
	fiss.saveInt("FISS_FollowerAlpha1", FollowerAlpha1)
	fiss.saveFloat("FISS_FollowerAlphaScript1", Follower1Script.Alpha)
	fiss.saveInt("FISS_FollowerScale1", FollowerScale1)
	fiss.saveInt("FISS_FollowerScaleScript1", Follower1Script.Size)
	fiss.saveInt("FISS_FollowerWidget2", FollowerWidget2)
	fiss.saveBool("FISS_FollowerWidgetScript2", Follower2Script.Visible)
	fiss.saveInt("FISS_FollowerPosX2", FollowerPosX2)
	fiss.saveFloat("FISS_FollowerPosXScript2", Follower2Script.X)
	fiss.saveInt("FISS_FollowerPosY2", FollowerPosY2)
	fiss.saveFloat("FISS_FollowerPosYScript2", Follower2Script.Y)
	fiss.saveInt("FISS_FollowerAlpha2", FollowerAlpha2)
	fiss.saveFloat("FISS_FollowerAlphaScript2", Follower2Script.Alpha)
	fiss.saveInt("FISS_FollowerScale2", FollowerScale2)
	fiss.saveInt("FISS_FollowerScaleScript2", Follower2Script.Size)
	fiss.saveInt("FISS_FollowerWidget3", FollowerWidget3)
	fiss.saveBool("FISS_FollowerWidgetScript3", Follower3Script.Visible)
	fiss.saveInt("FISS_FollowerPosX3", FollowerPosX3)
	fiss.saveFloat("FISS_FollowerPosXScript3", Follower3Script.X)
	fiss.saveInt("FISS_FollowerPosY3", FollowerPosY3)
	fiss.saveFloat("FISS_FollowerPosYScript3", Follower3Script.Y)
	fiss.saveInt("FISS_FollowerAlpha3", FollowerAlpha3)
	fiss.saveFloat("FISS_FollowerAlphaScript3", Follower3Script.Alpha)
	fiss.saveInt("FISS_FollowerScale3", FollowerScale3)
	fiss.saveInt("FISS_FollowerScaleScript3", Follower3Script.Size)
	fiss.saveInt("FISS_FollowerWidget4", FollowerWidget4)
	fiss.saveBool("FISS_FollowerWidgetScript4", Follower4Script.Visible)
	fiss.saveInt("FISS_FollowerPosX4", FollowerPosX4)
	fiss.saveFloat("FISS_FollowerPosXScript4", Follower4Script.X)
	fiss.saveInt("FISS_FollowerPosY4", FollowerPosY4)
	fiss.saveFloat("FISS_FollowerPosYScript4", Follower4Script.Y)
	fiss.saveInt("FISS_FollowerAlpha4", FollowerAlpha4)
	fiss.saveFloat("FISS_FollowerAlphaScript4", Follower4Script.Alpha)
	fiss.saveInt("FISS_FollowerScale4", FollowerScale4)
	fiss.saveInt("FISS_FollowerScaleScript4", Follower4Script.Size)
	fiss.saveInt("FISS_FollowerWidget5", FollowerWidget5)
	fiss.saveBool("FISS_FollowerWidgetScript5", Follower5Script.Visible)
	fiss.saveInt("FISS_FollowerPosX5", FollowerPosX5)
	fiss.saveFloat("FISS_FollowerPosXScript5", Follower5Script.X)
	fiss.saveInt("FISS_FollowerPosY5", FollowerPosY5)
	fiss.saveFloat("FISS_FollowerPosYScript5", Follower5Script.Y)
	fiss.saveInt("FISS_FollowerAlpha5", FollowerAlpha5)
	fiss.saveFloat("FISS_FollowerAlphaScript5", Follower5Script.Alpha)
	fiss.saveInt("FISS_FollowerScale5", FollowerScale5)
	fiss.saveInt("FISS_FollowerScaleScript5", Follower5Script.Size)	
	
	String saveResult = fiss.endSave()
	
EndFunction	