ScriptName FreeformSkyHavenTempleAScript extends Quest Conditional

DialogueFollowerScript property DialogueFollower auto
Armor property ArmorBlades5 auto
Weapon property AkaviriKatana auto
Armor property ArmorBlades1 auto
ReferenceAlias property Blade01 auto
Faction property BladesFaction auto
LeveledItem property LItemBanditWeaponMissile auto
Armor property ArmorBlades3 auto
Armor property ArmorBlades4 auto
Int property BladesCount auto conditional
ReferenceAlias property Blade02 auto
Faction property PotentialFollowerFaction auto
ReferenceAlias property Blade03 auto
Armor property ArmorBlades2 auto

Function RecruitBlade (Actor RecruitREF)

	if BladesCount == 0
		Blade01.ForceRefTo(RecruitREF)
		DialogueFollower.DismissFollower(0, 0, RecruitREF)
		BladesCount = 1
		self.SetStage(20)
	elseIf BladesCount == 1
		Blade02.ForceRefTo(RecruitREF)
		DialogueFollower.DismissFollower(0, 0, RecruitREF)
		BladesCount = 2
		self.SetStage(30)
	elseIf BladesCount == 2
		Blade03.ForceRefTo(RecruitREF)
		DialogueFollower.DismissFollower(0, 0, RecruitREF)
		BladesCount = 3
		self.SetStage(40)
	endIf

EndFunction

Function EquipBlade (Actor RecruitREF)

	RecruitREF.AddtoFaction(BladesFaction)
	RecruitREF.AddItem(ArmorBlades1, 1, false)
	RecruitREF.AddItem(ArmorBlades2, 1, false)
	RecruitREF.AddItem(ArmorBlades3, 1, false)
	RecruitREF.AddItem(ArmorBlades4, 1, false)
	RecruitREF.AddItem(ArmorBlades5, 1, false)
	RecruitREF.EquipItem(ArmorBlades1, false, false)
	RecruitREF.EquipItem(ArmorBlades2 , false, false)
	RecruitREF.EquipItem(ArmorBlades3, false, false)
	RecruitREF.EquipItem(ArmorBlades4, false, false)
	RecruitREF.EquipItem(ArmorBlades5, false, false)
	RecruitREF.AddItem(AkaviriKatana, 1, false)
	RecruitREF.EquipItem(AkaviriKatana, false, false)
	RecruitREF.AddItem(LItemBanditWeaponMissile, 1, false)

EndFunction